## scalapack 2.2.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.9)

project(SCALAPACK VERSION 2.2.1 LANGUAGES C Fortran)

# Configure the warning and code coverage suppression file
configure_file(
  "${SCALAPACK_SOURCE_DIR}/CMAKE/CTestCustom.cmake.in"
  "${SCALAPACK_BINARY_DIR}/CTestCustom.cmake"
  COPYONLY
)

# Add the CMake directory for custon CMake modules
set(CMAKE_MODULE_PATH "${SCALAPACK_SOURCE_DIR}/CMAKE" ${CMAKE_MODULE_PATH})

if (UNIX)
   if ("${CMAKE_Fortran_COMPILER_ID}" STREQUAL "Intel")
      set( CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -fltconsistency -fp_port" )
   endif ()
endif ()

#
#   MPI
#
set(CMAKE_PREFIX_PATH "${MPI_BASE_DIR};${CMAKE_PREFIX_PATH}")

find_package(MPI)
if (MPI_FOUND)
   message(STATUS "Found MPI_LIBRARY : ${MPI_FOUND} ")
   
   find_program(MPI_C_COMPILER
      NAMES mpicc
      HINTS "${MPI_BASE_DIR}"
      PATH_SUFFIXES bin
      DOC "MPI C compiler.")
   MARK_AS_ADVANCED(MPI_C_COMPILER)
   if ("${MPI_C_COMPILER}" STREQUAL "MPI_C_COMPILER-NOTFOUND")
      message(ERROR "--> MPI C Compiler NOT FOUND (please set MPI_BASE_DIR accordingly")
   else()
      message(STATUS "--> MPI C Compiler : ${MPI_C_COMPILER}")
      #SET(CMAKE_C_COMPILER "${MPI_C_COMPILER}")
      message(STATUS "--> C Compiler : ${CMAKE_C_COMPILER}")
   endif()
   find_program(MPI_Fortran_COMPILER
      NAMES mpif77
      HINTS "${MPI_BASE_DIR}"
      PATH_SUFFIXES bin
      DOC "MPI Fortran compiler.")
   MARK_AS_ADVANCED(MPI_Fortran_COMPILER)

   if ("${MPI_Fortran_COMPILER}" STREQUAL "MPI_Fortran_COMPILER-NOTFOUND")
      message(ERROR "--> MPI Fortran Compiler NOT FOUND (please set MPI_BASE_DIR accordingly")
   else()
      message(STATUS "--> MPI Fortran Compiler : ${MPI_Fortran_COMPILER}")
      SET(Fortran_COMPILER "${CMAKE_Fortran_COMPILER}")
      #SET(CMAKE_Fortran_COMPILER "${MPI_Fortran_COMPILER}")
      message(STATUS "--> Fortran Compiler : ${CMAKE_Fortran_COMPILER}")
   endif()

else()
   message(STATUS "Found MPI_LIBRARY : ${MPI_FOUND} ")
   set(MPI_BASE_DIR ${MPI_BASE_DIR} CACHE PATH "MPI Path")
   UNSET(MPIEXEC CACHE)
   UNSET(MPIEXEC_POSTFLAGS CACHE)
   UNSET(MPIEXEC_PREFLAGS CACHE)
   UNSET(MPIEXEC_MAX_NUMPROCS CACHE)
   UNSET(MPIEXEC_NUMPROC_FLAG CACHE)
   UNSET(MPI_COMPILE_FLAGS CACHE)
   UNSET(MPI_LINK_FLAGS CACHE)
   UNSET(MPI_INCLUDE_PATH CACHE)
   message(FATAL_ERROR "--> MPI Library NOT FOUND -- please set MPI_BASE_DIR accordingly --")
endif()


if (UNIX)
   if ("${CMAKE_Fortran_COMPILER_ID}" STREQUAL "Intel")
      set( CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -fltconsistency -fp_port" )
   endif ()
endif ()

macro(SCALAPACK_install_library lib)
  install(TARGETS ${lib} EXPORT scalapack-targets
    ARCHIVE DESTINATION lib${LIB_SUFFIX}
    LIBRARY DESTINATION lib${LIB_SUFFIX}
    RUNTIME DESTINATION Testing
  )
endmacro()

# --------------------------------------------------
# Testing
SET(DART_TESTING_TIMEOUT 600)

enable_testing()
include(CTest)
enable_testing()
# --------------------------------------------------

# Organize output files.  On Windows this also keeps .dll files next
# to the .exe files that need them, making tests easy to run.
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${SCALAPACK_BINARY_DIR}/TESTING)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${SCALAPACK_BINARY_DIR}/lib)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${SCALAPACK_BINARY_DIR}/lib)

# --------------------------------------------------
# By default static library
function (invertBoolean varName varValue)
  if (${varValue})
    set(${varName} false PARENT_SCOPE)
  else ()
    set(${varName} true PARENT_SCOPE)
  endif ()
endfunction ()
option(BUILD_SHARED_LIBS "Build shared libraries" OFF )
invertBoolean("BUILD_STATIC_LIBS" ${BUILD_SHARED_LIBS})
if ((${BUILD_SHARED_LIBS} EQUAL ON) AND NOT CMAKE_POSITION_INDEPENDENT_CODE)
  set(CMAKE_POSITION_INDEPENDENT_CODE ON)
endif ()

# --------------------------------------------------
# Check for any necessary platform specific compiler flags
include( CheckBLACSCompilerFlags )
CheckBLACSCompilerFlags()

set(prefix ${CMAKE_INSTALL_PREFIX})
set(libdir ${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX})
set(PKG_CONFIG_DIR ${libdir}/pkgconfig)

# --------------------------------------------------
# BLACS Internal variables
#
#   Fortran Mangling, MPI Tests and BLACS settings
#
include(FortranMangling)
COMPILE(install_COMPILED)

if (NOT DEFINED CDEFS)
  FORTRAN_MANGLING(CDEFS)
endif ()
#MESSAGE(STATUS "Setting CDEFS = ${CDEFS}")
#set(CDEFS ${CDEFS} CACHE STRING "Fortran Mangling" FORCE)
MESSAGE(STATUS "=========")

# --------------------------------------------------
# Compiler Flags
ADD_DEFINITIONS( "-D${CDEFS}")

# --------------------------------------------------
# ScaLAPACK needs BLAS and LAPACK

option(USE_OPTIMIZED_LAPACK_BLAS "Whether or not to search for optimized LAPACK and BLAS libraries on your machine (if not found, Reference LAPACK and BLAS will be downloaded and installed)" ON)

message(STATUS "CHECKING BLAS AND LAPACK LIBRARIES")

IF(LAPACK_LIBRARIES)
  include(CheckFortranFunctionExists)
  message(STATUS "--> LAPACK supplied by user is ${LAPACK_LIBRARIES}.")
  set(CMAKE_REQUIRED_LIBRARIES ${LAPACK_LIBRARIES})
  CHECK_FORTRAN_FUNCTION_EXISTS("dgesv" LAPACK_FOUND)
  unset( CMAKE_REQUIRED_LIBRARIES )
  message(STATUS "--> LAPACK routine dgesv is found: ${LAPACK_FOUND}.")
ENDIF()

if(LAPACK_FOUND)
      message(STATUS "--> LAPACK supplied by user is WORKING, will use ${LAPACK_LIBRARIES}.")
else(LAPACK_FOUND)
   if(USE_OPTIMIZED_LAPACK_BLAS)
      message(STATUS "--> Searching for optimized LAPACK and BLAS libraries on your machine.")
      find_package(LAPACK)
   ENDIF(USE_OPTIMIZED_LAPACK_BLAS)
   if(NOT LAPACK_FOUND)
      message(STATUS "--> LAPACK and BLAS were not found. Reference LAPACK and BLAS will be downloaded and installed")
      include(ExternalProject)
      ExternalProject_Add(
        lapack
        URL http://www.netlib.org/lapack/lapack.tgz
        CMAKE_ARGS -DCMAKE_INSTALL_PREFIX:PATH=${SCALAPACK_BINARY_DIR}
        PREFIX ${SCALAPACK_BINARY_DIR}/dependencies
      )
      if (NOT MSVC)
         SET(LAPACK_LIBRARIES ${SCALAPACK_BINARY_DIR}/lib/liblapack.a CACHE STRING "LAPACK library" FORCE)
         SET(BLAS_LIBRARIES ${SCALAPACK_BINARY_DIR}/lib/libblas.a CACHE STRING "BLAS library" FORCE)
      else () # MSVC
         SET(LAPACK_LIBRARIES ${SCALAPACK_BINARY_DIR}/lib/liblapack.lib CACHE STRING "LAPACK library" FORCE)
         SET(BLAS_LIBRARIES ${SCALAPACK_BINARY_DIR}/lib/libblas.lib CACHE STRING "BLAS library" FORCE)
      endif ()
   ENDIF()
ENDIF()

message(STATUS "BLAS library: ${BLAS_LIBRARIES}")
message(STATUS "LAPACK library: ${LAPACK_LIBRARIES}")

MESSAGE(STATUS "=========")

# --------------------------------------------------
# Subdirectories that need to be processed

macro(append_subdir_files variable dirname)
get_directory_property(holder DIRECTORY ${dirname} DEFINITION ${variable})
foreach(depfile ${holder})
  list(APPEND ${variable} "${dirname}/${depfile}")
endforeach()
endmacro()


#
# BLACS
#
add_subdirectory(BLACS)
append_subdir_files(blacs "BLACS/SRC")

#
# TOOLS
#
add_subdirectory(TOOLS)
append_subdir_files(tools TOOLS)
append_subdir_files(tools-C TOOLS)
append_subdir_files(extra_lapack "TOOLS/LAPACK")

#
# PBLAS
#
add_subdirectory(PBLAS)
append_subdir_files(pblas "PBLAS/SRC")
append_subdir_files(pblas-F "PBLAS/SRC")
append_subdir_files(pbblas "PBLAS/SRC/PBBLAS")
append_subdir_files(ptzblas "PBLAS/SRC/PTZBLAS")
append_subdir_files(ptools "PBLAS/SRC/PTOOLS")

#
# REDIST
#
add_subdirectory(REDIST)
append_subdir_files(redist "REDIST/SRC")

#
# SRC
#
add_subdirectory(SRC)
append_subdir_files(src "SRC")
append_subdir_files(src-C "SRC")

if (NOT MSVC)
   add_library(scalapack ${blacs} ${tools} ${tools-C} ${extra_lapack} ${pblas} ${pblas-F} ${ptzblas} ${ptools} ${pbblas} ${redist} ${src} ${src-C})
   set_target_properties(scalapack PROPERTIES
    VERSION ${SCALAPACK_VERSION}
    SOVERSION ${SCALAPACK_VERSION_MAJOR}.${SCALAPACK_VERSION_MINOR})
   target_link_libraries( scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_C)
   scalapack_install_library(scalapack)
else () # Need to separate Fortran and C Code
   OPTION(BUILD_SHARED_LIBS "Build shared libraries" ON )
   add_library(scalapack ${blacs} ${tools-C} ${pblas} ${ptools} ${redist} ${src-C})
   set_target_properties(scalapack PROPERTIES
    VERSION ${SCALAPACK_VERSION}
    SOVERSION ${SCALAPACK_VERSION_MAJOR}.${SCALAPACK_VERSION_MINOR})
   target_link_libraries( scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_C)
   add_library(scalapack-F ${pblas-F} ${pbblas} ${ptzblas} ${tools} ${src} ${extra_lapack} )
   set_target_properties(scalapack-F PROPERTIES
    VERSION ${SCALAPACK_VERSION}
    SOVERSION ${SCALAPACK_VERSION_MAJOR}.${SCALAPACK_VERSION_MINOR})
   target_link_libraries( scalapack-F ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)
   scalapack_install_library(scalapack)
   scalapack_install_library(scalapack-F)
endif ()

if(TARGET lapack)
   add_dependencies(scalapack lapack)
endif()

option(SCALAPACK_BUILD_TESTS "Build all tests of the ScaLAPACK library" ON)
if(${SCALAPACK_BUILD_TESTS})
  add_subdirectory(TESTING)
endif()

# --------------------------------------------------
# CPACK Packaging

SET(CPACK_PACKAGE_NAME "ScaLAPACK")
SET(CPACK_PACKAGE_VENDOR "University of Tennessee, Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd")
SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "ScaLAPACK- Linear Algebra Package")
set(CPACK_PACKAGE_VERSION_MAJOR ${SCALAPACK_VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${SCALAPACK_VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${SCALAPACK_VERSION_PATCH})
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE")
SET(CPACK_PACKAGE_INSTALL_DIRECTORY "SCALAPACK")
IF(WIN32 AND NOT UNIX)
  # There is a bug in NSI that does not handle full unix paths properly. Make
  # sure there is at least one set of four (4) backlasshes.
  SET(CPACK_NSIS_HELP_LINK "http:\\\\\\\\http://icl.cs.utk.edu/lapack-forum")
  SET(CPACK_NSIS_URL_INFO_ABOUT "http:\\\\\\\\www.netlib.org/scalapack")
  SET(CPACK_NSIS_CONTACT "scalapack@eecs.utk.edu")
  SET(CPACK_NSIS_MODIFY_PATH ON)
  SET(CPACK_NSIS_DISPLAY_NAME "SCALAPACK-${SCALAPACK_VERSION}")
  set(CPACK_PACKAGE_RELOCATABLE "true")
ELSE(WIN32 AND NOT UNIX)
  SET(CPACK_GENERATOR "TGZ")
  SET(CPACK_SOURCE_GENERATOR TGZ)
  SET(CPACK_SOURCE_PACKAGE_FILE_NAME "scalapack-${SCALAPACK_VERSION}" )
  SET(CPACK_SOURCE_IGNORE_FILES ~$ .svn ${CPACK_SOURCE_IGNORE_FILES} )
ENDIF(WIN32 AND NOT UNIX)
INCLUDE(CPack)


# --------------------------------------------------


export(TARGETS scalapack FILE scalapack-targets.cmake)

if( NOT LAPACK_FOUND )
 install(FILES
  ${BLAS_LIBRARIES} ${LAPACK_LIBRARIES}
  DESTINATION lib
   )
endif( NOT LAPACK_FOUND )

configure_file(${SCALAPACK_SOURCE_DIR}/CMAKE/scalapack-config-version.cmake.in
  ${SCALAPACK_BINARY_DIR}/scalapack-config-version.cmake @ONLY)
configure_file(${SCALAPACK_SOURCE_DIR}/CMAKE/scalapack-config-build.cmake.in
  ${SCALAPACK_BINARY_DIR}/scalapack-config.cmake @ONLY)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/scalapack.pc.in ${CMAKE_CURRENT_BINARY_DIR}/scalapack.pc)
 install(FILES
  ${CMAKE_CURRENT_BINARY_DIR}/scalapack.pc
  DESTINATION ${PKG_CONFIG_DIR}
   )

configure_file(${SCALAPACK_SOURCE_DIR}/CMAKE/scalapack-config-install.cmake.in
  ${SCALAPACK_BINARY_DIR}/CMakeFiles/scalapack-config.cmake @ONLY)
install(FILES
  ${SCALAPACK_BINARY_DIR}/CMakeFiles/scalapack-config.cmake
  ${SCALAPACK_BINARY_DIR}/scalapack-config-version.cmake
  DESTINATION lib/cmake/scalapack-${SCALAPACK_VERSION}
  )

install(EXPORT scalapack-targets
  DESTINATION lib/cmake/scalapack-${SCALAPACK_VERSION})

=== Makefile ===
############################################################################
#
#  Program:         ScaLAPACK
#
#  Module:          Makefile
#
#  Purpose:         Top-level Makefile
#
#  Creation date:   March 20, 1995
#
#  Modified:        February 15, 2000
#
#  Send bug reports, comments or suggestions to scalapack@cs.utk.edu
#
############################################################################

include SLmake.inc

PRECISIONS = single double complex complex16

############################################################################
#
#  The library can be set up to include routines for any combination of the
#  four PRECISIONS.  First, modify the ARCH, ARCHFLAGS, RANLIB, F77, CC,
#  F77FLAGS, CCFLAGS, F77LOADER, CCLOADER, F77LOADFLAGS, CCLOADFLAGS and
#  CDEFS definitions in SLmake.inc to match your library archiver, compiler
#  and the options to be used.
#
#  The command
#       make
#  without any arguments creates the library of precisions defined by the
#  environment variable PRECISIONS as well as the corresponding testing
#  executables,
#       make lib
#  creates only the library,
#       make exe
#  creates only the testing executables.
#       make example
#  creates only the example
#
#  The name of the library is defined in the file called SLmake.inc and
#  is created at this directory level.
#
#  To remove the object files after the library and testing executables
#  are created, enter
#       make clean
#
############################################################################

all: lib exe example

SCALAPACKLIBS=toolslib pblaslib redistlib scalapacklib

$(SCALAPACKLIBS): blacslib
lib: $(SCALAPACKLIBS)

exe: blacsexe pblasexe redistexe scalapackexe

clean: cleanlib cleanexe cleanexample

blacslib:
	( cd BLACS; $(MAKE) lib )

pblaslib:
	( cd PBLAS/SRC; $(MAKE) $(PRECISIONS) )

redistlib:
	( cd REDIST/SRC; $(MAKE) integer $(PRECISIONS) )

scalapacklib:
	( cd SRC; $(MAKE) $(PRECISIONS) )

toolslib:
	( cd TOOLS; $(MAKE) $(PRECISIONS) )

blacsexe:
	( cd BLACS; $(MAKE) tester )

pblasexe:
	( cd PBLAS/TESTING; $(MAKE) $(PRECISIONS) )
	( cd PBLAS/TIMING; $(MAKE) $(PRECISIONS) )

scalapackexe:
	( cd TESTING/LIN; $(MAKE) $(PRECISIONS) )
	( cd TESTING/EIG; $(MAKE) $(PRECISIONS) )

redistexe:
	( cd REDIST/TESTING; $(MAKE) integer $(PRECISIONS) )

example:
	( cd EXAMPLE; $(MAKE) $(PRECISIONS) )

cleanexe:
	( cd PBLAS/TESTING; $(MAKE) clean )
	( cd PBLAS/TIMING; $(MAKE) clean )
	( cd TESTING/LIN; $(MAKE) clean )
	( cd TESTING/EIG; $(MAKE) clean )
	( cd REDIST/TESTING; $(MAKE) clean )
	( cd BLACS/TESTING; $(MAKE) clean )
	( cd TESTING; rm -f x* )

cleanlib:
	( cd BLACS; $(MAKE) clean )
	( cd PBLAS/SRC; $(MAKE) clean )
	( cd SRC; $(MAKE) clean )
	( cd TOOLS; $(MAKE) clean )
	( cd REDIST/SRC; $(MAKE) clean )
	( rm -f $(SCALAPACKLIB) )

cleanexample:
	( cd EXAMPLE; $(MAKE) clean )

=== BLACS/Makefile ===
all : lib tester

clean:
	( cd TESTING ; $(MAKE) clean )
	( cd SRC ; $(MAKE) clean )

tester :
	( cd TESTING ; $(MAKE) )

lib :
	( cd SRC ; $(MAKE) )

=== SRC/CMakeLists.txt ===
set (ALLAUX  pjlaenv.f  pilaenvx.f piparmq.f pilaver.f pmpim2.f pmpcol.f)
set (ALLAUX-C  pbchkvect.c getpbbuf.c pcrot.c pslaiect.c pdlaiect.c pzrot.c slamov.c clamov.c dlamov.c zlamov.c)

set (SCLAUX  
   pslabad.f pslaed0.f pslaed1.f pslaed2.f pslaed3.f pslaedz.f 
   pslamch.f pslared1d.f pslasrt.f psstebz.f psstedc.f slapst.f slasrt2.f 
   sstein2.f
   slar1va.f slarrb2.f slarrd2.f slarre2.f slarre2a.f slarrf2.f
   slarrv2.f sstegr2.f sstegr2a.f sstegr2b.f)

set (DZLAUX  
   pdlabad.f pdlaed0.f pdlaed1.f pdlaed2.f pdlaed3.f pdlaedz.f 
   pdlamch.f pdlared1d.f pdlasrt.f pdstebz.f pdstedc.f dlapst.f dlasrt2.f 
   dstein2.f
   dlar1va.f dlarrb2.f dlarrd2.f dlarre2.f dlarre2a.f dlarrf2.f
   dlarrv2.f dstegr2.f dstegr2a.f dstegr2b.f)

set (SLASRC  
   psdbsv.f  psdbtrf.f psdbtrs.f psdbtrsv.f 
   psdtsv.f  psdttrf.f psdttrs.f psdttrsv.f 
   psgbsv.f  psgbtrf.f psgbtrs.f 
   psgebd2.f psgebrd.f psgecon.f pstrcon.f psgeequ.f psgehd2.f psgehrd.f
   psgelq2.f psgelqf.f psgels.f  psgeql2.f psgeqlf.f psgeqpf.f psgeqr2.f 
   psgeqrf.f psgerfs.f psgerq2.f psgerqf.f                               
   psgesv.f  psgesvd.f psgesvx.f psgetf2.f psgetrf.f psgetri.f psgetrs.f 
   psggqrf.f psggrqf.f pslabrd.f 
   pslacon.f pslacp2.f pslacpy.f pslahrd.f pslange.f pslanhs.f pslansy.f 
   pslantr.f pslapiv.f pslapv2.f pslaqge.f pslaqsy.f pslarf.f  pslarfb.f 
   pslarfg.f pslarft.f pslase2.f pslaset.f pslascl.f pslassq.f pslaswp.f 
   pslatra.f pslatrd.f pslatrs.f pslauu2.f pslauum.f psorg2l.f psorg2r.f 
                       psorgl2.f psorglq.f psorgql.f psorgqr.f psorgr2.f 
   psorgrq.f           psorm2l.f psorm2r.f psormbr.f psormhr.f psorml2.f 
   psormlq.f psormql.f psormqr.f psormr2.f psormrq.f psormtr.f pspocon.f 
   pspbsv.f  pspbtrf.f pspbtrs.f pspbtrsv.f 
   psptsv.f  pspttrf.f pspttrs.f pspttrsv.f 
   pspoequ.f psporfs.f psposv.f  psposvx.f pspotf2.f pspotrf.f pspotri.f 
   pspotrs.f psrscl.f  psstein.f pssyev.f  pssyevd.f pssyevx.f 
   pssygs2.f pssygst.f 
   pssygvx.f pssyngst.f pssyntrd.f  pssyttrd.f pssytd2.f pssytrd.f 
   pstrti2.f pstrtri.f pstrtrs.f pstrrfs.f
   pslaevswp.f 
   pslarzb.f pslarzt.f pslarz.f pslatrz.f pstzrzf.f psormr3.f psormrz.f 
   pslahqr.f pslaconsb.f pslacp3.f pslawil.f 
   pslasmsub.f pslared2d.f pslamr1d.f slaref.f slamsh.f slasorte.f ssteqr2.f 
   sdbtf2.f  sdbtrf.f  sdttrf.f sdttrsv.f spttrsv.f strmvt.f pssyevr.f
   bslaapp.f bslaexc.f bstrexc.f pstrord.f pstrsen.f psgebal.f pshseqr.f
   pslamve.f pslaqr0.f pslaqr1.f pslaqr2.f pslaqr3.f pslaqr4.f pslaqr5.f
   psrot.f slaqr6.f)
   
set (CLASRC  
   pcdbsv.f  pcdbtrf.f pcdbtrs.f pcdbtrsv.f 
   pcdtsv.f  pcdttrf.f pcdttrs.f pcdttrsv.f 
   pcgbsv.f  pcgbtrf.f pcgbtrs.f 
   pcgebd2.f pcgebrd.f pcgecon.f pctrcon.f pcgeequ.f pcgehd2.f pcgehrd.f
   pcgelq2.f pcgelqf.f  pcgels.f pcgeql2.f pcgeqlf.f pcgeqpf.f pcgeqr2.f 
   pcgeqrf.f pcgerfs.f pcgerq2.f pcgerqf.f                               
   pcgesv.f  pcgesvd.f pcgesvx.f pcgetf2.f pcgetrf.f pcgetri.f pcgetrs.f 
   pcggqrf.f 
   pcggrqf.f pcheev.f  pcheevd.f pcheevx.f pchegs2.f pchegst.f pchegvx.f 
   pchengst.f pchentrd.f pchettrd.f pchetd2.f 
   pchetrd.f pclabrd.f pclacon.f pclacgv.f pclacp2.f pclacpy.f pclahrd.f 
   pclahqr.f pclaconsb.f pclasmsub.f pclacp3.f pclawil.f
   pclange.f pclanhe.f pclanhs.f pclansy.f pclantr.f pclapiv.f pclapv2.f 
   pclaqge.f pclaqsy.f pclarf.f  pclarfb.f pclarfc.f pclarfg.f pclarft.f 
   pclascl.f pclase2.f pclaset.f pclassq.f pclaswp.f pclatra.f pclatrd.f 
   pclatrs.f pclauu2.f pclauum.f pcpocon.f pcpoequ.f pcporfs.f pcposv.f  
   pcpbsv.f  pcpbtrf.f pcpbtrs.f pcpbtrsv.f 
   pcptsv.f  pcpttrf.f pcpttrs.f pcpttrsv.f 
   pcposvx.f pcpotf2.f pcpotrf.f pcpotri.f pcpotrs.f pcsrscl.f pcstein.f 
   pctrevc.f pctrti2.f pctrtri.f pctrtrs.f pctrrfs.f pcung2l.f pcung2r.f 
             pcungl2.f pcunglq.f pcungql.f pcungqr.f pcungr2.f pcungrq.f 
             pcunm2l.f pcunm2r.f pcunmbr.f pcunmhr.f pcunml2.f pcunmlq.f 
   pcunmql.f pcunmqr.f pcunmr2.f pcunmrq.f pcunmtr.f 
   pclaevswp.f 
   pclarzb.f pclarzt.f pclarz.f  pclarzc.f pclatrz.f pctzrzf.f 
   pclattrs.f 
   pcunmr3.f pcunmrz.f pcmax1.f pscsum1.f pclamr1d.f 
   cdbtf2.f  cdbtrf.f  cdttrf.f cdttrsv.f  cpttrsv.f csteqr2.f ctrmvt.f 
   clamsh.f  claref.f  clanv2.f clahqr2.f pcheevr.f)

set (DLASRC  
   pddbsv.f  pddbtrf.f pddbtrs.f pddbtrsv.f 
   pddtsv.f  pddttrf.f pddttrs.f pddttrsv.f 
   pdgbsv.f  pdgbtrf.f pdgbtrs.f 
   pdgebd2.f pdgebrd.f pdgecon.f pdtrcon.f pdgeequ.f pdgehd2.f pdgehrd.f
   pdgelq2.f pdgelqf.f pdgels.f  pdgeql2.f pdgeqlf.f pdgeqpf.f pdgeqr2.f 
   pdgeqrf.f pdgerfs.f pdgerq2.f pdgerqf.f                               
   pdgesv.f  pdgesvd.f pdgesvx.f pdgetf2.f pdgetrf.f pdgetri.f pdgetrs.f 
   pdggqrf.f pdggrqf.f pdlabrd.f 
   pdlacon.f pdlacp2.f pdlacpy.f pdlahrd.f pdlange.f pdlanhs.f pdlansy.f 
   pdlantr.f pdlapiv.f pdlapv2.f pdlaqge.f pdlaqsy.f pdlarf.f  pdlarfb.f 
   pdlarfg.f pdlarft.f pdlase2.f pdlaset.f pdlascl.f pdlassq.f pdlaswp.f 
   pdlatra.f pdlatrd.f pdlatrs.f pdlauu2.f pdlauum.f pdorg2l.f pdorg2r.f 
                       pdorgl2.f pdorglq.f pdorgql.f pdorgqr.f pdorgr2.f 
   pdorgrq.f           pdorm2l.f pdorm2r.f pdormbr.f pdormhr.f pdorml2.f 
   pdormlq.f pdormql.f pdormqr.f pdormr2.f pdormrq.f pdormtr.f pdpocon.f 
   pdpbsv.f  pdpbtrf.f pdpbtrs.f pdpbtrsv.f 
   pdptsv.f  pdpttrf.f pdpttrs.f pdpttrsv.f 
   pdpoequ.f pdporfs.f pdposv.f  pdposvx.f pdpotf2.f pdpotrf.f pdpotri.f 
   pdpotrs.f pdrscl.f  pdstein.f pdsyev.f  pdsyevd.f pdsyevx.f 
   pdsygs2.f pdsygst.f 
   pdsygvx.f pdsyngst.f pdsyntrd.f pdsyttrd.f pdsytd2.f pdsytrd.f pdtrti2.f 
   pdtrtri.f pdtrtrs.f pdtrrfs.f
   pdlaevswp.f 
   pdlarzb.f pdlarzt.f pdlarz.f pdlatrz.f pdtzrzf.f pdormr3.f pdormrz.f 
   pdlahqr.f pdlaconsb.f pdlacp3.f pdlawil.f 
   pdlasmsub.f pdlared2d.f pdlamr1d.f dlaref.f dlamsh.f dlasorte.f dsteqr2.f 
   ddbtf2.f  ddbtrf.f  ddttrf.f ddttrsv.f dpttrsv.f dtrmvt.f  pdsyevr.f
   bdlaapp.f bdlaexc.f bdtrexc.f dlaqr6.f pdtrord.f
   pdtrsen.f pdgebal.f pdhseqr.f pdlamve.f pdlaqr0.f pdlaqr1.f pdlaqr2.f
   pdlaqr3.f pdlaqr4.f pdlaqr5.f pdrot.f)

set (ZLASRC  
   pzdbsv.f  pzdbtrf.f pzdbtrs.f pzdbtrsv.f 
   pzdtsv.f  pzdttrf.f pzdttrs.f pzdttrsv.f 
   pzgbsv.f  pzgbtrf.f pzgbtrs.f 
   pzgebd2.f pzgebrd.f pzgecon.f pztrcon.f pzgeequ.f pzgehd2.f pzgehrd.f
   pzgelq2.f pzgelqf.f pzgels.f  pzgeql2.f pzgeqlf.f pzgeqpf.f pzgeqr2.f 
   pzgeqrf.f pzgerfs.f pzgerq2.f pzgerqf.f                               
   pzgesv.f  pzgesvd.f pzgesvx.f pzgetf2.f pzgetrf.f pzgetri.f pzgetrs.f 
   pzggqrf.f 
   pzggrqf.f pzheev.f  pzheevd.f pzheevx.f pzhegs2.f pzhegst.f pzhegvx.f 
   pzhengst.f pzhentrd.f pzhettrd.f pzhetd2.f 
   pzhetrd.f pzlabrd.f pzlacon.f pzlacgv.f pzlacp2.f pzlacpy.f pzlahrd.f 
   pzlahqr.f pzlaconsb.f pzlasmsub.f pzlacp3.f pzlawil.f 
   pzlange.f pzlanhe.f pzlanhs.f pzlansy.f pzlantr.f pzlapiv.f pzlapv2.f 
   pzlaqge.f pzlaqsy.f pzlarf.f  pzlarfb.f pzlarfc.f pzlarfg.f pzlarft.f 
   pzlascl.f pzlase2.f pzlaset.f pzlassq.f pzlaswp.f pzlatra.f pzlatrd.f 
   pzlattrs.f 
   pzlatrs.f pzlauu2.f pzlauum.f pzpocon.f pzpoequ.f pzporfs.f pzposv.f  
   pzpbsv.f  pzpbtrf.f pzpbtrs.f pzpbtrsv.f 
   pzptsv.f  pzpttrf.f pzpttrs.f pzpttrsv.f 
   pzposvx.f pzpotf2.f pzpotrf.f pzpotri.f pzpotrs.f pzdrscl.f pzstein.f 
   pztrevc.f pztrti2.f pztrtri.f pztrtrs.f pztrrfs.f pzung2l.f pzung2r.f 
             pzungl2.f pzunglq.f pzungql.f pzungqr.f pzungr2.f pzungrq.f 
             pzunm2l.f pzunm2r.f pzunmbr.f pzunmhr.f pzunml2.f pzunmlq.f 
   pzunmql.f pzunmqr.f pzunmr2.f pzunmrq.f pzunmtr.f 
   pzlaevswp.f 
   pzlarzb.f pzlarzt.f pzlarz.f  pzlarzc.f pzlatrz.f pztzrzf.f 
   pzunmr3.f pzunmrz.f pzmax1.f pdzsum1.f pzlamr1d.f 
   zdbtf2.f  zdbtrf.f  zdttrf.f zdttrsv.f  zpttrsv.f zsteqr2.f ztrmvt.f 
   zlamsh.f  zlaref.f  zlanv2.f zlahqr2.f pzheevr.f)
   
set(src 
      ${ALLAUX} ${SCLAUX} ${DZLAUX}
      ${SLASRC} ${CLASRC} ${DLASRC} ${ZLASRC} )
set(src-C 
      ${ALLAUX-C} )

=== SRC/Makefile ===
############################################################################
#
#  Program:         ScaLAPACK
#
#  Module:          Makefile
#
#  Purpose:         SRC Makefile
#
#  Creation date:   March 20, 1995
#
#  Modified:
#
#  Send bug reports, comments or suggestions to scalapack@cs.utk.edu
#
############################################################################

include ../SLmake.inc

#######################################################################
#  This is the makefile to create a library for ScaLAPACK.
#  The files are organized as follows:
#       ALLAUX -- Auxiliary routines called from all precisions
#       SCLAUX -- Auxiliary routines called from both REAL and COMPLEX
#       DZLAUX -- Auxiliary routines called from both DOUBLE PRECISION
#                 and COMPLEX*16
#       SLASRC -- Single precision real ScaLAPACK routines
#       CLASRC -- Single precision complex ScaLAPACK routines
#       DLASRC -- Double precision real ScaLAPACK routines
#       ZLASRC -- Double precision complex ScaLAPACK routines
#
#  The library can be set up to include routines for any combination
#  of the four precisions.  First, modify the ARCH, ARCHFLAGS, RANLIB,
#  FC and FCFLAGS definitions in ../SLmake.inc to match your library
#  archiver, compiler and the options to be used.
#  Then to create or add to the library, enter make followed by one or
#  more of the precisions desired.  Some examples:
#       make single
#       make single complex
#       make single double complex complex16
#  Alternatively, the command
#       make
#  without any arguments creates a library of all four precisions.
#  The name of the library is defined by ../$(SCALAPACKLIB) in
#  ../SLmake.inc and is created at the next higher directory level.
#
#  To remove the object files after the library is created, enter
#       make clean
#
#######################################################################

ALLAUX = pjlaenv.o pbchkvect.o getpbbuf.o pilaenvx.o piparmq.o pilaver.o pmpim2.o pmpcol.o

SCLAUX = \
   pslabad.o pslaed0.o pslaed1.o pslaed2.o pslaed3.o pslaedz.o pslaiect.o \
   pslamch.o pslared1d.o pslasrt.o psstebz.o psstedc.o slapst.o slasrt2.o \
   sstein2.o \
   slar1va.o slarrb2.o slarrd2.o slarre2.o slarre2a.o slarrf2.o \
   slarrv2.o sstegr2.o sstegr2a.o sstegr2b.o slamov.o clamov.o

DZLAUX = \
   pdlabad.o pdlaed0.o pdlaed1.o pdlaed2.o pdlaed3.o pdlaedz.o pdlaiect.o \
   pdlamch.o pdlared1d.o pdlasrt.o pdstebz.o pdstedc.o dlapst.o dlasrt2.o \
   dstein2.o \
   dlar1va.o dlarrb2.o dlarrd2.o dlarre2.o dlarre2a.o dlarrf2.o \
   dlarrv2.o dstegr2.o dstegr2a.o dstegr2b.o dlamov.o zlamov.o

SLASRC = \
   psdbsv.o  psdbtrf.o psdbtrs.o psdbtrsv.o \
   psdtsv.o  psdttrf.o psdttrs.o psdttrsv.o \
   psgbsv.o  psgbtrf.o psgbtrs.o \
   psgebd2.o psgebrd.o psgecon.o pstrcon.o psgeequ.o psgehd2.o psgehrd.o \
   psgelq2.o psgelqf.o psgels.o  psgeql2.o psgeqlf.o psgeqpf.o psgeqr2.o \
   psgeqrf.o psgerfs.o psgerq2.o psgerqf.o                               \
   psgesv.o  psgesvd.o psgesvx.o psgetf2.o psgetrf.o psgetri.o psgetrs.o \
   psggqrf.o psggrqf.o pslabrd.o \
   pslacon.o pslacp2.o pslacpy.o pslahrd.o pslange.o pslanhs.o pslansy.o \
   pslantr.o pslapiv.o pslapv2.o pslaqge.o pslaqsy.o pslarf.o  pslarfb.o \
   pslarfg.o pslarft.o pslase2.o pslaset.o pslascl.o pslassq.o pslaswp.o \
   pslatra.o pslatrd.o pslatrs.o pslauu2.o pslauum.o psorg2l.o psorg2r.o \
                       psorgl2.o psorglq.o psorgql.o psorgqr.o psorgr2.o \
   psorgrq.o           psorm2l.o psorm2r.o psormbr.o psormhr.o psorml2.o \
   psormlq.o psormql.o psormqr.o psormr2.o psormrq.o psormtr.o pspocon.o \
   pspbsv.o  pspbtrf.o pspbtrs.o pspbtrsv.o \
   psptsv.o  pspttrf.o pspttrs.o pspttrsv.o \
   pspoequ.o psporfs.o psposv.o  psposvx.o pspotf2.o pspotrf.o pspotri.o \
   pspotrs.o psrscl.o  psstein.o pssyev.o  pssyevd.o pssyevx.o \
   pssygs2.o pssygst.o \
   pssygvx.o pssyngst.o pssyntrd.o  pssyttrd.o pssytd2.o pssytrd.o \
   pstrti2.o pstrtri.o pstrtrs.o pstrrfs.o \
   pslaevswp.o \
   pslarzb.o pslarzt.o pslarz.o pslatrz.o pstzrzf.o psormr3.o psormrz.o \
   pslahqr.o pslaconsb.o pslacp3.o pslawil.o \
   pslasmsub.o pslared2d.o pslamr1d.o slaref.o slamsh.o slasorte.o ssteqr2.o \
   sdbtf2.o  sdbtrf.o  sdttrf.o sdttrsv.o spttrsv.o strmvt.o pssyevr.o \
   bslaapp.o bslaexc.o bstrexc.o pstrord.o pstrsen.o psgebal.o pshseqr.o \
   pslamve.o pslaqr0.o pslaqr1.o pslaqr2.o pslaqr3.o pslaqr4.o pslaqr5.o \
   psrot.o slaqr6.o

CLASRC = \
   pcdbsv.o  pcdbtrf.o pcdbtrs.o pcdbtrsv.o \
   pcdtsv.o  pcdttrf.o pcdttrs.o pcdttrsv.o \
   pcgbsv.o  pcgbtrf.o pcgbtrs.o \
   pcgebd2.o pcgebrd.o pcgecon.o pctrcon.o pcgeequ.o pcgehd2.o pcgehrd.o \
   pcgelq2.o pcgelqf.o  pcgels.o pcgeql2.o pcgeqlf.o pcgeqpf.o pcgeqr2.o \
   pcgeqrf.o pcgerfs.o pcgerq2.o pcgerqf.o                               \
   pcgesv.o  pcgesvd.o pcgesvx.o pcgetf2.o pcgetrf.o pcgetri.o pcgetrs.o \
   pcggqrf.o \
   pcggrqf.o pcheev.o  pcheevd.o pcheevx.o pchegs2.o pchegst.o pchegvx.o \
   pchengst.o pchentrd.o pchettrd.o pchetd2.o \
   pchetrd.o pclabrd.o pclacon.o pclacgv.o pclacp2.o pclacpy.o pclahrd.o \
   pclahqr.o pclaconsb.o pclasmsub.o pclacp3.o pclawil.o pcrot.o \
   pclange.o pclanhe.o pclanhs.o pclansy.o pclantr.o pclapiv.o pclapv2.o \
   pclaqge.o pclaqsy.o pclarf.o  pclarfb.o pclarfc.o pclarfg.o pclarft.o \
   pclascl.o pclase2.o pclaset.o pclassq.o pclaswp.o pclatra.o pclatrd.o \
   pclatrs.o pclauu2.o pclauum.o pcpocon.o pcpoequ.o pcporfs.o pcposv.o  \
   pcpbsv.o  pcpbtrf.o pcpbtrs.o pcpbtrsv.o \
   pcptsv.o  pcpttrf.o pcpttrs.o pcpttrsv.o \
   pcposvx.o pcpotf2.o pcpotrf.o pcpotri.o pcpotrs.o pcsrscl.o pcstein.o \
   pctrevc.o pctrti2.o pctrtri.o pctrtrs.o pctrrfs.o pcung2l.o pcung2r.o \
             pcungl2.o pcunglq.o pcungql.o pcungqr.o pcungr2.o pcungrq.o \
             pcunm2l.o pcunm2r.o pcunmbr.o pcunmhr.o pcunml2.o pcunmlq.o \
   pcunmql.o pcunmqr.o pcunmr2.o pcunmrq.o pcunmtr.o \
   pclaevswp.o \
   pclarzb.o pclarzt.o pclarz.o  pclarzc.o pclatrz.o pctzrzf.o \
   pclattrs.o \
   pcunmr3.o pcunmrz.o pcmax1.o pscsum1.o pclamr1d.o \
   cdbtf2.o  cdbtrf.o  cdttrf.o cdttrsv.o  cpttrsv.o csteqr2.o ctrmvt.o \
   clamsh.o  claref.o  clanv2.o clahqr2.o pcheevr.o

DLASRC = \
   pddbsv.o  pddbtrf.o pddbtrs.o pddbtrsv.o \
   pddtsv.o  pddttrf.o pddttrs.o pddttrsv.o \
   pdgbsv.o  pdgbtrf.o pdgbtrs.o \
   pdgebd2.o pdgebrd.o pdgecon.o pdtrcon.o pdgeequ.o pdgehd2.o pdgehrd.o \
   pdgelq2.o pdgelqf.o pdgels.o  pdgeql2.o pdgeqlf.o pdgeqpf.o pdgeqr2.o \
   pdgeqrf.o pdgerfs.o pdgerq2.o pdgerqf.o                               \
   pdgesv.o  pdgesvd.o pdgesvx.o pdgetf2.o pdgetrf.o pdgetri.o pdgetrs.o \
   pdggqrf.o pdggrqf.o pdlabrd.o \
   pdlacon.o pdlacp2.o pdlacpy.o pdlahrd.o pdlange.o pdlanhs.o pdlansy.o \
   pdlantr.o pdlapiv.o pdlapv2.o pdlaqge.o pdlaqsy.o pdlarf.o  pdlarfb.o \
   pdlarfg.o pdlarft.o pdlase2.o pdlaset.o pdlascl.o pdlassq.o pdlaswp.o \
   pdlatra.o pdlatrd.o pdlatrs.o pdlauu2.o pdlauum.o pdorg2l.o pdorg2r.o \
                       pdorgl2.o pdorglq.o pdorgql.o pdorgqr.o pdorgr2.o \
   pdorgrq.o           pdorm2l.o pdorm2r.o pdormbr.o pdormhr.o pdorml2.o \
   pdormlq.o pdormql.o pdormqr.o pdormr2.o pdormrq.o pdormtr.o pdpocon.o \
   pdpbsv.o  pdpbtrf.o pdpbtrs.o pdpbtrsv.o \
   pdptsv.o  pdpttrf.o pdpttrs.o pdpttrsv.o \
   pdpoequ.o pdporfs.o pdposv.o  pdposvx.o pdpotf2.o pdpotrf.o pdpotri.o \
   pdpotrs.o pdrscl.o  pdstein.o pdsyev.o  pdsyevd.o pdsyevx.o \
   pdsygs2.o pdsygst.o \
   pdsygvx.o pdsyngst.o pdsyntrd.o pdsyttrd.o pdsytd2.o pdsytrd.o pdtrti2.o \
   pdtrtri.o pdtrtrs.o pdtrrfs.o \
   pdlaevswp.o \
   pdlarzb.o pdlarzt.o pdlarz.o pdlatrz.o pdtzrzf.o pdormr3.o pdormrz.o \
   pdlahqr.o pdlaconsb.o pdlacp3.o pdlawil.o \
   pdlasmsub.o pdlared2d.o pdlamr1d.o dlaref.o dlamsh.o dlasorte.o dsteqr2.o \
   ddbtf2.o  ddbtrf.o  ddttrf.o ddttrsv.o dpttrsv.o dtrmvt.o pdsyevr.o \
   bdlaapp.o bdlaexc.o bdtrexc.o dlaqr6.o pdtrord.o \
   pdtrsen.o pdgebal.o pdhseqr.o pdlamve.o pdlaqr0.o pdlaqr1.o pdlaqr2.o \
   pdlaqr3.o pdlaqr4.o pdlaqr5.o pdrot.o

ZLASRC = \
   pzdbsv.o  pzdbtrf.o pzdbtrs.o pzdbtrsv.o \
   pzdtsv.o  pzdttrf.o pzdttrs.o pzdttrsv.o \
   pzgbsv.o  pzgbtrf.o pzgbtrs.o \
   pzgebd2.o pzgebrd.o pzgecon.o pztrcon.o pzgeequ.o pzgehd2.o pzgehrd.o \
   pzgelq2.o pzgelqf.o pzgels.o  pzgeql2.o pzgeqlf.o pzgeqpf.o pzgeqr2.o \
   pzgeqrf.o pzgerfs.o pzgerq2.o pzgerqf.o                               \
   pzgesv.o  pzgesvd.o pzgesvx.o pzgetf2.o pzgetrf.o pzgetri.o pzgetrs.o \
   pzggqrf.o \
   pzggrqf.o pzheev.o  pzheevd.o pzheevx.o pzhegs2.o pzhegst.o pzhegvx.o \
   pzhengst.o pzhentrd.o pzhettrd.o pzhetd2.o \
   pzhetrd.o pzlabrd.o pzlacon.o pzlacgv.o pzlacp2.o pzlacpy.o pzlahrd.o \
   pzlahqr.o pzlaconsb.o pzlasmsub.o pzlacp3.o pzlawil.o pzrot.o \
   pzlange.o pzlanhe.o pzlanhs.o pzlansy.o pzlantr.o pzlapiv.o pzlapv2.o \
   pzlaqge.o pzlaqsy.o pzlarf.o  pzlarfb.o pzlarfc.o pzlarfg.o pzlarft.o \
   pzlascl.o pzlase2.o pzlaset.o pzlassq.o pzlaswp.o pzlatra.o pzlatrd.o \
   pzlattrs.o \
   pzlatrs.o pzlauu2.o pzlauum.o pzpocon.o pzpoequ.o pzporfs.o pzposv.o  \
   pzpbsv.o  pzpbtrf.o pzpbtrs.o pzpbtrsv.o \
   pzptsv.o  pzpttrf.o pzpttrs.o pzpttrsv.o \
   pzposvx.o pzpotf2.o pzpotrf.o pzpotri.o pzpotrs.o pzdrscl.o pzstein.o \
   pztrevc.o pztrti2.o pztrtri.o pztrtrs.o pztrrfs.o pzung2l.o pzung2r.o \
             pzungl2.o pzunglq.o pzungql.o pzungqr.o pzungr2.o pzungrq.o \
             pzunm2l.o pzunm2r.o pzunmbr.o pzunmhr.o pzunml2.o pzunmlq.o \
   pzunmql.o pzunmqr.o pzunmr2.o pzunmrq.o pzunmtr.o \
   pzlaevswp.o \
   pzlarzb.o pzlarzt.o pzlarz.o  pzlarzc.o pzlatrz.o pztzrzf.o \
   pzunmr3.o pzunmrz.o pzmax1.o pdzsum1.o pzlamr1d.o \
   zdbtf2.o  zdbtrf.o  zdttrf.o zdttrsv.o  zpttrsv.o zsteqr2.o ztrmvt.o \
   zlamsh.o  zlaref.o  zlanv2.o zlahqr2.o pzheevr.o

all: single complex double complex16

single: $(SLASRC) $(SCLAUX) $(ALLAUX)
	$(ARCH) $(ARCHFLAGS) ../$(SCALAPACKLIB) $(SLASRC) $(SCLAUX) \
	$(ALLAUX)
	$(RANLIB) ../$(SCALAPACKLIB)

complex: $(CLASRC) $(SCLAUX) $(ALLAUX)
	$(ARCH) $(ARCHFLAGS) ../$(SCALAPACKLIB) $(CLASRC) $(SCLAUX) \
	$(ALLAUX)
	$(RANLIB) ../$(SCALAPACKLIB)

double: $(DLASRC) $(DZLAUX) $(ALLAUX)
	$(ARCH) $(ARCHFLAGS) ../$(SCALAPACKLIB) $(DLASRC) $(DZLAUX) \
	$(ALLAUX)
	$(RANLIB) ../$(SCALAPACKLIB)

complex16: $(ZLASRC) $(DZLAUX) $(ALLAUX)
	$(ARCH) $(ARCHFLAGS) ../$(SCALAPACKLIB) $(ZLASRC) $(DZLAUX) \
	$(ALLAUX)
	$(RANLIB) ../$(SCALAPACKLIB)

slamov.o: slamov.c
dlamov.o: dlamov.c
clamov.o: clamov.c
zlamov.o: zlamov.c
slamov.o dlamov.o clamov.o zlamov.o: lamov.h
	$(CC) -c $(CFLAGS) $(CDEFS) $(@:.o=.c) -o $@

clean :
	rm -f *.o

.f.o : 
	$(FC) -c $(FCFLAGS) $*.f

.c.o : 
	$(CC) -c $(CDEFS) $(CCFLAGS) $*.c

=== TESTING/CMakeLists.txt ===
add_subdirectory(LIN)
add_subdirectory(EIG)

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${SCALAPACK_BINARY_DIR}/TESTING)

file(COPY BLLT.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY BLU.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY BRD.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY EVC.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY HRD.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY INV.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY LLT.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY LS.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY LU.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY NEP.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY QR.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY SEP.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY SEPR.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY SVD.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY TRD.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})

add_test(xslu ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ./xslu)
add_test(xdlu ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ./xdlu)
add_test(xclu ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ./xclu)
add_test(xzlu ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ./xzlu)

add_test(xsdblu ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ./xsdblu)
add_test(xddblu ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ./xddblu)
add_test(xcdblu ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ./xcdblu)
add_test(xzdblu ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ./xzdblu)

add_test(xsdtlu ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ./xsdtlu)
add_test(xddtlu ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ./xddtlu)
add_test(xcdtlu ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ./xcdtlu)
add_test(xzdtlu ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ./xzdtlu)

add_test(xsgblu ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ./xsgblu)
add_test(xdgblu ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ./xdgblu)
add_test(xcgblu ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ./xcgblu)
add_test(xzgblu ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ./xzgblu)

add_test(xsllt ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ./xsllt)
add_test(xdllt ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ./xdllt)
add_test(xcllt ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ./xcllt)
add_test(xzllt ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ./xzllt)

add_test(xspbllt ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ./xspbllt)
add_test(xdpbllt ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ./xdpbllt)
add_test(xcpbllt ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ./xcpbllt)
add_test(xzpbllt ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ./xzpbllt)

add_test(xsptllt ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ./xsptllt)
add_test(xdptllt ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ./xdptllt)
add_test(xcptllt ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ./xcptllt)
add_test(xzptllt ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ./xzptllt)

add_test(xsinv ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ./xsinv)
add_test(xdinv ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ./xdinv)
add_test(xcinv ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ./xcinv)
add_test(xzinv ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ./xzinv)

add_test(xsqr ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ./xsqr)
add_test(xdqr ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ./xdqr)
add_test(xcqr ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ./xcqr)
add_test(xzqr ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ./xzqr)

add_test(xsbrd ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ./xsbrd)
add_test(xdbrd ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ./xdbrd)
add_test(xcbrd ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ./xcbrd)
add_test(xzbrd ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ./xzbrd)

add_test(xshrd ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ./xshrd)
add_test(xdhrd ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ./xdhrd)
add_test(xchrd ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ./xchrd)
add_test(xzhrd ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ./xzhrd)

add_test(xstrd ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ./xstrd)
add_test(xdtrd ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ./xdtrd)
add_test(xctrd ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ./xctrd)
add_test(xztrd ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ./xztrd)

add_test(xssvd ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ${MPIEXEC_PREFLAGS} ./xssvd)
add_test(xdsvd ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ${MPIEXEC_PREFLAGS} ./xdsvd)

add_test(xssep ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ${MPIEXEC_PREFLAGS} ./xssep)
add_test(xdsep ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ${MPIEXEC_PREFLAGS} ./xdsep)
add_test(xcsep ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ${MPIEXEC_PREFLAGS} ./xcsep)
add_test(xzsep ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ${MPIEXEC_PREFLAGS} ./xzsep)

add_test(xsgsep ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ${MPIEXEC_PREFLAGS} ./xsgsep)
add_test(xdgsep ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ${MPIEXEC_PREFLAGS} ./xdgsep)
add_test(xcgsep ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ${MPIEXEC_PREFLAGS} ./xcgsep)
add_test(xzgsep ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ${MPIEXEC_PREFLAGS} ./xzgsep)

add_test(xsnep ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ./xsnep)
add_test(xdnep ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ./xdnep)
add_test(xcnep ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ./xcnep)
add_test(xznep ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ./xznep)

add_test(xcevc ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ./xcevc)
add_test(xzevc ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ./xzevc)

add_test(xssyevr ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ${MPIEXEC_PREFLAGS} ./xssyevr)
add_test(xdsyevr ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ${MPIEXEC_PREFLAGS} ./xdsyevr)
add_test(xcheevr ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ${MPIEXEC_PREFLAGS} ./xcheevr)
add_test(xzheevr ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ${MPIEXEC_PREFLAGS} ./xzheevr)

add_test(xshseqr ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ./xshseqr)
add_test(xdhseqr ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ./xdhseqr)

=== BLACS/TESTING/CMakeLists.txt ===
set(FTestObj
   blacstest.f btprim.f tools.f)

if ("${CMAKE_Fortran_COMPILER_ID}" STREQUAL "GNU" AND CMAKE_Fortran_COMPILER_VERSION VERSION_GREATER_EQUAL 10)
    set_source_files_properties(blacstest.f PROPERTIES COMPILE_FLAGS "-std=legacy")
endif()

add_executable(xFbtest ${FTestObj})
target_link_libraries(xFbtest scalapack MPI::MPI_Fortran)

set(CTestObj
   Cbt.c)

set_property(
   SOURCE Cbt.c
   APPEND PROPERTY COMPILE_DEFINITIONS BTCINTFACE
   )

add_executable(xCbtest ${CTestObj} ${FTestObj})
target_link_libraries(xCbtest scalapack MPI::MPI_Fortran)

file(COPY bsbr.dat DESTINATION ${SCALAPACK_BINARY_DIR}/BLACS/TESTING)
file(COPY bt.dat DESTINATION ${SCALAPACK_BINARY_DIR}/BLACS/TESTING)
file(COPY comb.dat DESTINATION ${SCALAPACK_BINARY_DIR}/BLACS/TESTING)
file(COPY sdrv.dat DESTINATION ${SCALAPACK_BINARY_DIR}/BLACS/TESTING)

# We could run the BLACS TESTING the following way
# But BLACS TESTING are TESTING anormal exit so even if they pass,
# CTest will determine they fail
#add_test(xFbtest0 ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ${MPIEXEC_PREFLAGS} ./xFbtest)
#add_test(xCbtest0 ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ${MPIEXEC_PREFLAGS} ./xCbtest)

add_test(xCbtest
     ${CMAKE_COMMAND}
    -DMPIEXEC=${MPIEXEC}
    -DMPIEXEC_NUMPROC_FLAG=${MPIEXEC_NUMPROC_FLAG}
    -DMPIEXEC_PREFLAGS=${MPIEXEC_PREFLAGS}
    -DTEST_PROG=xCbtest
    -DOUTPUTDIR=${SCALAPACK_BINARY_DIR}/BLACS/TESTING
    -DRUNTIMEDIR=${CMAKE_RUNTIME_OUTPUT_DIRECTORY}
    -DSOURCEDIR=${CMAKE_CURRENT_SOURCE_DIR}
    -P ${CMAKE_CURRENT_SOURCE_DIR}/runtest.cmake
    )

add_test(xFbtest
     ${CMAKE_COMMAND}
    -DMPIEXEC=${MPIEXEC}
    -DMPIEXEC_NUMPROC_FLAG=${MPIEXEC_NUMPROC_FLAG}
    -DMPIEXEC_PREFLAGS=${MPIEXEC_PREFLAGS}
    -DTEST_PROG=xFbtest
    -DOUTPUTDIR=${SCALAPACK_BINARY_DIR}/BLACS/TESTING
    -DRUNTIMEDIR=${CMAKE_RUNTIME_OUTPUT_DIRECTORY}
    -DSOURCEDIR=${CMAKE_CURRENT_SOURCE_DIR}
    -P ${CMAKE_CURRENT_SOURCE_DIR}/runtest.cmake
    )

=== PBLAS/TESTING/CMakeLists.txt ===
file(COPY ../SRC/PTOOLS/PB_Cwarn.c DESTINATION ${CMAKE_CURRENT_SOURCE_DIR})
file(COPY ../SRC/PTOOLS/PB_Cabort.c DESTINATION ${CMAKE_CURRENT_SOURCE_DIR})

set (PblasErrorHandler  PB_Cwarn.c PB_Cabort.c)
set (pbtcom pblastst.f ${PblasErrorHandler})
set (spbtcom psblastst.f slamch.f ${pbtcom})
set (dpbtcom pdblastst.f dlamch.f ${pbtcom})
set (cpbtcom pcblastst.f slamch.f ${pbtcom})
set (zpbtcom pzblastst.f dlamch.f ${pbtcom})

set_property(
   SOURCE ${PblasErrorHandler}
   APPEND PROPERTY COMPILE_DEFINITIONS TestingPblas
   )

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${SCALAPACK_BINARY_DIR}/PBLAS/TESTING)

file(COPY PCBLAS1TST.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY PCBLAS2TST.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY PCBLAS3TST.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY PDBLAS1TST.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY PDBLAS2TST.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY PDBLAS3TST.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY PSBLAS1TST.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY PSBLAS2TST.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY PSBLAS3TST.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY PZBLAS1TST.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY PZBLAS2TST.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY PZBLAS3TST.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})


add_executable(spb1tst psblas1tst.f ${spbtcom})
add_executable(dpb1tst pdblas1tst.f ${dpbtcom})
add_executable(cpb1tst pcblas1tst.f ${cpbtcom})
add_executable(zpb1tst pzblas1tst.f ${zpbtcom})

add_executable(spb2tst psblas2tst.f ${spbtcom})
add_executable(dpb2tst pdblas2tst.f ${dpbtcom})
add_executable(cpb2tst pcblas2tst.f ${cpbtcom})
add_executable(zpb2tst pzblas2tst.f ${zpbtcom})

add_executable(spb3tst psblas3tst.f ${spbtcom})
add_executable(dpb3tst pdblas3tst.f ${dpbtcom})
add_executable(cpb3tst pcblas3tst.f ${cpbtcom})
add_executable(zpb3tst pzblas3tst.f ${zpbtcom})

target_link_libraries(spb1tst scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)
target_link_libraries(dpb1tst scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)
target_link_libraries(cpb1tst scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)
target_link_libraries(zpb1tst scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)

target_link_libraries(spb2tst scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)
target_link_libraries(dpb2tst scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)
target_link_libraries(cpb2tst scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)
target_link_libraries(zpb2tst scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)

target_link_libraries(spb3tst scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)
target_link_libraries(dpb3tst scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)
target_link_libraries(cpb3tst scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)
target_link_libraries(zpb3tst scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)

add_test(spb1tst ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ${MPIEXEC_PREFLAGS} ./spb1tst)
add_test(dpb1tst ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ${MPIEXEC_PREFLAGS} ./dpb1tst)
add_test(cpb1tst ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ${MPIEXEC_PREFLAGS} ./cpb1tst)
add_test(zpb1tst ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ${MPIEXEC_PREFLAGS} ./zpb1tst)

add_test(spb2tst ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ${MPIEXEC_PREFLAGS} ./spb2tst)
add_test(dpb2tst ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ${MPIEXEC_PREFLAGS} ./dpb2tst)
add_test(cpb2tst ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ${MPIEXEC_PREFLAGS} ./cpb2tst)
add_test(zpb2tst ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ${MPIEXEC_PREFLAGS} ./zpb2tst)

add_test(spb3tst ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ${MPIEXEC_PREFLAGS} ./spb3tst)
add_test(dpb3tst ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ${MPIEXEC_PREFLAGS} ./dpb3tst)
add_test(cpb3tst ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ${MPIEXEC_PREFLAGS} ./cpb3tst)
add_test(zpb3tst ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ${MPIEXEC_PREFLAGS} ./zpb3tst)

if ("${CMAKE_Fortran_COMPILER_ID}" STREQUAL "GNU" AND CMAKE_Fortran_COMPILER_VERSION VERSION_GREATER_EQUAL 10)
    set( CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -std=legacy" )  # local to this directory
endif()

=== PBLAS/TESTING/Makefile ===
############################################################################
#
#  Program:         PBLAS -- (version 2.0)
#
#  Module:          Makefile
#
#  Purpose:         Testing Makefile
#
#  Creation date:   April 1, 1998
#
#  Modified:        February 15, 2000
#
#  Send bug reports, comments or suggestions to scalapack@cs.utk.edu
#
############################################################################

include ../../SLmake.inc

sPBLAS1exe    = xspblas1tst
dPBLAS1exe    = xdpblas1tst
cPBLAS1exe    = xcpblas1tst
zPBLAS1exe    = xzpblas1tst

sPBLAS2exe    = xspblas2tst
dPBLAS2exe    = xdpblas2tst
cPBLAS2exe    = xcpblas2tst
zPBLAS2exe    = xzpblas2tst

sPBLAS3exe    = xspblas3tst
dPBLAS3exe    = xdpblas3tst
cPBLAS3exe    = xcpblas3tst
zPBLAS3exe    = xzpblas3tst

spb1tst       = $(sPBLAS1exe)
dpb1tst       = $(dPBLAS1exe)
cpb1tst       = $(cPBLAS1exe)
zpb1tst       = $(zPBLAS1exe)

spb2tst       = $(sPBLAS2exe)
dpb2tst       = $(dPBLAS2exe)
cpb2tst       = $(cPBLAS2exe)
zpb2tst       = $(zPBLAS2exe)

spb3tst       = $(sPBLAS3exe)
dpb3tst       = $(dPBLAS3exe)
cpb3tst       = $(cPBLAS3exe)
zpb3tst       = $(zPBLAS3exe)

pbtcom        = pblastst.o PB_Cwarn.o PB_Cabort.o

spbtcom       = psblastst.o slamch.o $(pbtcom)
dpbtcom       = pdblastst.o dlamch.o $(pbtcom)
cpbtcom       = pcblastst.o slamch.o $(pbtcom)
zpbtcom       = pzblastst.o dlamch.o $(pbtcom)

spb1t         = psblas1tst.o $(spbtcom)
dpb1t         = pdblas1tst.o $(dpbtcom)
cpb1t         = pcblas1tst.o $(cpbtcom)
zpb1t         = pzblas1tst.o $(zpbtcom)

spb2t         = psblas2tst.o $(spbtcom)
dpb2t         = pdblas2tst.o $(dpbtcom)
cpb2t         = pcblas2tst.o $(cpbtcom)
zpb2t         = pzblas2tst.o $(zpbtcom)

spb3t         = psblas3tst.o $(spbtcom)
dpb3t         = pdblas3tst.o $(dpbtcom)
cpb3t         = pcblas3tst.o $(cpbtcom)
zpb3t         = pzblas3tst.o $(zpbtcom)

all : single double complex complex16

single:    PblasErrorHandler $(spb1tst) $(spb2tst) $(spb3tst)

double:    PblasErrorHandler $(dpb1tst) $(dpb2tst) $(dpb3tst)

complex:   PblasErrorHandler $(cpb1tst) $(cpb2tst) $(cpb3tst)

complex16: PblasErrorHandler $(zpb1tst) $(zpb2tst) $(zpb3tst)

PB_Cwarn.o:
	$(CC) -c $(CDEFS) $(CCFLAGS) -I../SRC -o PB_Cwarn.o -DTestingPblas ../SRC/PTOOLS/PB_Cwarn.c

PB_Cabort.o:
	$(CC) -c $(CDEFS) $(CCFLAGS) -I../SRC -o PB_Cabort.o -DTestingPblas ../SRC/PTOOLS/PB_Cabort.c

PblasErrorHandler:  PB_Cwarn.o  PB_Cwarn.o

$(spb1tst) : ../../$(SCALAPACKLIB) $(spb1t)
	$(FCLOADER) $(FCLOADFLAGS) -o $(spb1tst) $(spb1t) ../../$(SCALAPACKLIB) $(LIBS)

$(dpb1tst) : ../../$(SCALAPACKLIB) $(dpb1t)
	$(FCLOADER) $(FCLOADFLAGS) -o $(dpb1tst) $(dpb1t) ../../$(SCALAPACKLIB) $(LIBS)

$(cpb1tst) : ../../$(SCALAPACKLIB) $(cpb1t)
	$(FCLOADER) $(FCLOADFLAGS) -o $(cpb1tst) $(cpb1t) ../../$(SCALAPACKLIB) $(LIBS)

$(zpb1tst) : ../../$(SCALAPACKLIB) $(zpb1t)
	$(FCLOADER) $(FCLOADFLAGS) -o $(zpb1tst) $(zpb1t) ../../$(SCALAPACKLIB) $(LIBS)

$(spb2tst) : ../../$(SCALAPACKLIB) $(spb2t)
	$(FCLOADER) $(FCLOADFLAGS) -o $(spb2tst) $(spb2t) ../../$(SCALAPACKLIB) $(LIBS)

$(dpb2tst) : ../../$(SCALAPACKLIB) $(dpb2t)
	$(FCLOADER) $(FCLOADFLAGS) -o $(dpb2tst) $(dpb2t) ../../$(SCALAPACKLIB) $(LIBS)

$(cpb2tst) : ../../$(SCALAPACKLIB) $(cpb2t)
	$(FCLOADER) $(FCLOADFLAGS) -o $(cpb2tst) $(cpb2t) ../../$(SCALAPACKLIB) $(LIBS)

$(zpb2tst) : ../../$(SCALAPACKLIB) $(zpb2t)
	$(FCLOADER) $(FCLOADFLAGS) -o $(zpb2tst) $(zpb2t) ../../$(SCALAPACKLIB) $(LIBS)

$(spb3tst) : ../../$(SCALAPACKLIB) $(spb3t)
	$(FCLOADER) $(FCLOADFLAGS) -o $(spb3tst) $(spb3t) ../../$(SCALAPACKLIB) $(LIBS)

$(dpb3tst) : ../../$(SCALAPACKLIB) $(dpb3t)
	$(FCLOADER) $(FCLOADFLAGS) -o $(dpb3tst) $(dpb3t) ../../$(SCALAPACKLIB) $(LIBS)

$(cpb3tst) : ../../$(SCALAPACKLIB) $(cpb3t)
	$(FCLOADER) $(FCLOADFLAGS) -o $(cpb3tst) $(cpb3t) ../../$(SCALAPACKLIB) $(LIBS)

$(zpb3tst) : ../../$(SCALAPACKLIB) $(zpb3t)
	$(FCLOADER) $(FCLOADFLAGS) -o $(zpb3tst) $(zpb3t) ../../$(SCALAPACKLIB) $(LIBS)

clean :
	rm -f *.o x*

slamch.o:
	$(FC) -c $(NOOPT) slamch.f

dlamch.o:
	$(FC) -c $(NOOPT) dlamch.f

.f.o : ; $(FC) -c $(FCFLAGS) $*.f

.c.o : ; $(CC) -c $(CDEFS) $(CCFLAGS) -DTestingPblas $*.c

=== PBLAS/TIMING/CMakeLists.txt ===
file(COPY ../SRC/PTOOLS/PB_Cwarn.c DESTINATION ${CMAKE_CURRENT_SOURCE_DIR})
file(COPY ../SRC/PTOOLS/PB_Cabort.c DESTINATION ${CMAKE_CURRENT_SOURCE_DIR})

set (PblasErrorHandler  PB_Cwarn.c PB_Cabort.c)
set (pbtcom pblastim.f ${PblasErrorHandler})
set (spbtcom psblastim.f ${pbtcom})
set (dpbtcom pdblastim.f ${pbtcom})
set (cpbtcom pcblastim.f ${pbtcom})
set (zpbtcom pzblastim.f ${pbtcom})
   
set_property(
   SOURCE ${PblasErrorHandler}
   APPEND PROPERTY COMPILE_DEFINITIONS TestingPblas 
   )

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${SCALAPACK_BINARY_DIR}/PBLAS/TIMING)

file(COPY PCBLAS1TIM.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY PCBLAS2TIM.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY PCBLAS3TIM.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY PDBLAS1TIM.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY PDBLAS2TIM.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY PDBLAS3TIM.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY PSBLAS1TIM.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY PSBLAS2TIM.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY PSBLAS3TIM.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY PZBLAS1TIM.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY PZBLAS2TIM.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY PZBLAS3TIM.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})


add_executable(spb1tim psblas1tim.f ${spbtcom})
add_executable(dpb1tim pdblas1tim.f ${dpbtcom})
add_executable(cpb1tim pcblas1tim.f ${cpbtcom})
add_executable(zpb1tim pzblas1tim.f ${zpbtcom})

add_executable(spb2tim psblas2tim.f ${spbtcom})
add_executable(dpb2tim pdblas2tim.f ${dpbtcom})
add_executable(cpb2tim pcblas2tim.f ${cpbtcom})
add_executable(zpb2tim pzblas2tim.f ${zpbtcom})

add_executable(spb3tim psblas3tim.f ${spbtcom})
add_executable(dpb3tim pdblas3tim.f ${dpbtcom})
add_executable(cpb3tim pcblas3tim.f ${cpbtcom})
add_executable(zpb3tim pzblas3tim.f ${zpbtcom})

target_link_libraries(spb1tim scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)
target_link_libraries(dpb1tim scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)
target_link_libraries(cpb1tim scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)
target_link_libraries(zpb1tim scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)

target_link_libraries(spb2tim scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)
target_link_libraries(dpb2tim scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)
target_link_libraries(cpb2tim scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)
target_link_libraries(zpb2tim scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)

target_link_libraries(spb3tim scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)
target_link_libraries(dpb3tim scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)
target_link_libraries(cpb3tim scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)
target_link_libraries(zpb3tim scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)

add_test(spb1tim ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ${MPIEXEC_PREFLAGS} ./spb1tim)
add_test(dpb1tim ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ${MPIEXEC_PREFLAGS} ./dpb1tim)
add_test(cpb1tim ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ${MPIEXEC_PREFLAGS} ./cpb1tim)
add_test(zpb1tim ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ${MPIEXEC_PREFLAGS} ./zpb1tim)

add_test(spb2tim ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ${MPIEXEC_PREFLAGS} ./spb2tim)
add_test(dpb2tim ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ${MPIEXEC_PREFLAGS} ./dpb2tim)
add_test(cpb2tim ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ${MPIEXEC_PREFLAGS} ./cpb2tim)
add_test(zpb2tim ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ${MPIEXEC_PREFLAGS} ./zpb2tim)

add_test(spb3tim ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ${MPIEXEC_PREFLAGS} ./spb3tim)
add_test(dpb3tim ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ${MPIEXEC_PREFLAGS} ./dpb3tim)
add_test(cpb3tim ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ${MPIEXEC_PREFLAGS} ./cpb3tim)
add_test(zpb3tim ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ${MPIEXEC_PREFLAGS} ./zpb3tim)

if ("${CMAKE_Fortran_COMPILER_ID}" STREQUAL "GNU" AND CMAKE_Fortran_COMPILER_VERSION VERSION_GREATER_EQUAL 10)
    set( CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -std=legacy" )  # local to this directory
endif()

=== REDIST/TESTING/CMakeLists.txt ===
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${SCALAPACK_BINARY_DIR}/scalapack/REDIST/TESTING)

file(COPY GEMR2D.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY TRMR2D.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})

add_executable(xigemr pigemrdrv.c)
add_executable(xsgemr psgemrdrv.c)
add_executable(xdgemr pdgemrdrv.c)
add_executable(xcgemr pcgemrdrv.c)
add_executable(xzgemr pzgemrdrv.c)

add_executable(xitrmr pitrmrdrv.c)
add_executable(xstrmr pstrmrdrv.c)
add_executable(xdtrmr pdtrmrdrv.c)
add_executable(xctrmr pctrmrdrv.c)
add_executable(xztrmr pztrmrdrv.c)

target_link_libraries(xigemr scalapack MPI::MPI_Fortran )
target_link_libraries(xsgemr scalapack MPI::MPI_Fortran )
target_link_libraries(xdgemr scalapack MPI::MPI_Fortran )
target_link_libraries(xcgemr scalapack MPI::MPI_Fortran )
target_link_libraries(xzgemr scalapack MPI::MPI_Fortran )

target_link_libraries(xitrmr scalapack MPI::MPI_Fortran )
target_link_libraries(xstrmr scalapack MPI::MPI_Fortran )
target_link_libraries(xdtrmr scalapack MPI::MPI_Fortran )
target_link_libraries(xctrmr scalapack MPI::MPI_Fortran )
target_link_libraries(xztrmr scalapack MPI::MPI_Fortran )

#add_test(xigemr ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ${MPIEXEC_PREFLAGS} ./xigemr)
#add_test(xsgemr ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ${MPIEXEC_PREFLAGS} ./xsgemr)
#add_test(xdgemr ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ${MPIEXEC_PREFLAGS} ./xdgemr)
#add_test(xcgemr ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ${MPIEXEC_PREFLAGS} ./xcgemr)
#add_test(xzgemr ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ${MPIEXEC_PREFLAGS} ./xzgemr)

#add_test(xitrmr ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ${MPIEXEC_PREFLAGS} ./xitrmr)
#add_test(xstrmr ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ${MPIEXEC_PREFLAGS} ./xstrmr)
#add_test(xdtrmr ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ${MPIEXEC_PREFLAGS} ./xdtrmr)
#add_test(xctrmr ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ${MPIEXEC_PREFLAGS} ./xctrmr)
#add_test(xztrmr ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ${MPIEXEC_PREFLAGS} ./xztrmr)

=== TESTING/EIG/CMakeLists.txt ===
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${SCALAPACK_BINARY_DIR}/TESTING)

set (smatgen psmatgen.f pmatgeninc.f)
set (dmatgen pdmatgen.f pmatgeninc.f)
set (cmatgen pcmatgen.f pmatgeninc.f)
set (zmatgen pzmatgen.f pmatgeninc.f)

add_executable(xsbrd psbrddriver.f psbrdinfo.f psgebdrv.f pslafchk.f ${smatgen})
add_executable(xdbrd pdbrddriver.f pdbrdinfo.f pdgebdrv.f pdlafchk.f ${dmatgen})
add_executable(xcbrd pcbrddriver.f pcbrdinfo.f pcgebdrv.f pclafchk.f ${cmatgen})
add_executable(xzbrd pzbrddriver.f pzbrdinfo.f pzgebdrv.f pzlafchk.f ${zmatgen})

add_executable(xshrd pshrddriver.f pshrdinfo.f psgehdrv.f pslafchk.f ${smatgen})
add_executable(xdhrd pdhrddriver.f pdhrdinfo.f pdgehdrv.f pdlafchk.f ${dmatgen})
add_executable(xchrd pchrddriver.f pchrdinfo.f pcgehdrv.f pclafchk.f ${cmatgen})
add_executable(xzhrd pzhrddriver.f pzhrdinfo.f pzgehdrv.f pzlafchk.f ${zmatgen})

add_executable(xstrd pstrddriver.f psttrdtester.f pslatran.f pstrdinfo.f pssytdrv.f pslafchk.f xpjlaenv.f ${smatgen})
add_executable(xdtrd pdtrddriver.f pdttrdtester.f pdlatran.f pdtrdinfo.f pdsytdrv.f pdlafchk.f xpjlaenv.f ${dmatgen})
add_executable(xctrd pctrddriver.f pcttrdtester.f pclatran.f pctrdinfo.f pchetdrv.f pclafchk.f xpjlaenv.f ${cmatgen})
add_executable(xztrd pztrddriver.f pzttrdtester.f pzlatran.f pztrdinfo.f pzhetdrv.f pzlafchk.f xpjlaenv.f ${zmatgen})

add_executable(xssvd pssvddriver.f pslagge.f pssvdchk.f pssvdcmp.f pssvdtst.f ${smatgen})
add_executable(xdsvd pdsvddriver.f pdlagge.f pdsvdchk.f pdsvdcmp.f pdsvdtst.f ${dmatgen})

add_executable(xssep psseptst.f pssepsubtst.f pssepchk.f pssepqtq.f pslagsy.f pslatms.f pslasizesep.f pslasizesyevx.f pssepdriver.f pssepreq.f pssepinfo.f pslasizesyev.f pssqpsubtst.f pslasizesqp.f pssdpsubtst.f ${smatgen})
add_executable(xdsep pdseptst.f pdsepsubtst.f pdsepchk.f pdsepqtq.f pdlagsy.f pdlatms.f pdlasizesep.f pdlasizesyevx.f pdsepdriver.f pdsepreq.f pdsepinfo.f pdlasizesyev.f pdsqpsubtst.f pdlasizesqp.f pdsdpsubtst.f ${dmatgen})
add_executable(xcsep pcseptst.f pcsepsubtst.f pcsepchk.f pcsepqtq.f pclagsy.f pclatms.f pclasizesep.f pclasizeheevx.f pcsepdriver.f pcsepreq.f pssepinfo.f pcsdpsubtst.f ${cmatgen})
add_executable(xzsep pzseptst.f pzsepsubtst.f pzsepchk.f pzsepqtq.f pzlagsy.f pzlatms.f pzlasizesep.f pzlasizeheevx.f pzsepdriver.f pzsepreq.f pdsepinfo.f pzsdpsubtst.f ${zmatgen})

add_executable(xsgsep psgseptst.f psgsepsubtst.f psgsepchk.f pslagsy.f pslatms.f pslasizesyevx.f pslasizegsep.f pslasizesep.f psgsepdriver.f psgsepreq.f pssepinfo.f ${smatgen})
add_executable(xdgsep pdgseptst.f pdgsepsubtst.f pdgsepchk.f pdlagsy.f pdlatms.f pdlasizesyevx.f pdlasizegsep.f pdlasizesep.f pdgsepdriver.f pdgsepreq.f pdsepinfo.f ${dmatgen})
add_executable(xcgsep pcgseptst.f pcgsepsubtst.f pcgsepchk.f pclagsy.f pclatms.f pclasizegsep.f pclasizeheevx.f pclasizesep.f pcgsepdriver.f pcgsepreq.f pssepinfo.f ${cmatgen})
add_executable(xzgsep pzgseptst.f pzgsepsubtst.f pzgsepchk.f pzlagsy.f pzlatms.f pzlasizegsep.f pzlasizeheevx.f pzlasizesep.f pzgsepdriver.f pzgsepreq.f pdsepinfo.f ${zmatgen})

add_executable(xsnep psnepdriver.f psnepinfo.f psnepfchk.f ${smatgen})
add_executable(xdnep pdnepdriver.f pdnepinfo.f pdnepfchk.f ${dmatgen})
add_executable(xcnep pcnepdriver.f pcnepinfo.f pcnepfchk.f ${cmatgen})
add_executable(xznep pznepdriver.f pznepinfo.f pznepfchk.f ${zmatgen})

add_executable(xcevc pcevcdriver.f pcevcinfo.f pcget22.f ${cmatgen})
add_executable(xzevc pzevcdriver.f pzevcinfo.f pzget22.f ${zmatgen})

add_executable(xssyevr pslasizesepr.f pslasizesyevr.f psseprdriver.f psseprreq.f psseprsubtst.f
pssepchk.f pssepqtq.f pslatms.f psseprtst.f pssepinfo.f pslagsy.f pslasizesep.f ${smatgen})
add_executable(xdsyevr  pdlasizesepr.f pdlasizesyevr.f pdseprdriver.f pdseprreq.f pdseprsubtst.f
pdsepchk.f pdsepqtq.f pdlatms.f pdseprtst.f pdsepinfo.f pdlagsy.f pdlasizesep.f ${dmatgen}) 
add_executable(xcheevr pclasizesepr.f pclasizeheevr.f pcseprdriver.f pcseprreq.f pcseprsubtst.f
pcsepchk.f pcsepqtq.f pclatms.f pcseprtst.f pssepinfo.f pclagsy.f pclasizesep.f ${cmatgen})
add_executable(xzheevr  pzlasizesepr.f pzlasizeheevr.f pzseprdriver.f pzseprreq.f pzseprsubtst.f
pzsepchk.f pzsepqtq.f pzlatms.f pzseprtst.f pdsepinfo.f pzlagsy.f pzlasizesep.f ${zmatgen})

add_executable(xshseqr pshseqrdriver.f psmatgen2.f ${cmatgen})
add_executable(xdhseqr pdhseqrdriver.f pdmatgen2.f ${cmatgen})

target_link_libraries(xsbrd scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)
target_link_libraries(xdbrd scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)
target_link_libraries(xcbrd scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)
target_link_libraries(xzbrd scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)

target_link_libraries(xshrd scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)
target_link_libraries(xdhrd scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)
target_link_libraries(xchrd scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)
target_link_libraries(xzhrd scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)

target_link_libraries(xstrd scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)
target_link_libraries(xdtrd scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)
target_link_libraries(xctrd scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)
target_link_libraries(xztrd scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)

target_link_libraries(xssvd scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)
target_link_libraries(xdsvd scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)

target_link_libraries(xssep scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)
target_link_libraries(xdsep scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)
target_link_libraries(xcsep scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)
target_link_libraries(xzsep scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)

target_link_libraries(xsgsep scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)
target_link_libraries(xdgsep scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)
target_link_libraries(xcgsep scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)
target_link_libraries(xzgsep scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)

target_link_libraries(xsnep scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)
target_link_libraries(xdnep scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)
target_link_libraries(xcnep scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)
target_link_libraries(xznep scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)

target_link_libraries(xcevc scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)
target_link_libraries(xzevc scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)

target_link_libraries(xssyevr scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)
target_link_libraries(xdsyevr scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)
target_link_libraries(xcheevr scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)
target_link_libraries(xzheevr scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)

target_link_libraries(xshseqr scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)
target_link_libraries(xdhseqr scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} MPI::MPI_Fortran)

if ("${CMAKE_Fortran_COMPILER_ID}" STREQUAL "GNU" AND CMAKE_Fortran_COMPILER_VERSION VERSION_GREATER_EQUAL 10)
    set( CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -std=legacy" )  # local to this directory
endif()

=== debian/changelog ===
scalapack (2.2.2-2) unstable; urgency=medium

  * add debian patches applying upstream patches
    - cmake4_PR123.patch applies upstream PR#124 to update
      required cmake versions. Closes: #1113484
    - fix_C23_gcc15_PR139.patch applies upstream PR#139 to
      fix build with gcc-15 (C23). Closes: #1097848.
  * debian patch blacs_no_testing.patch deactivates BLACS/TESTING,
    which is currently broken. Also REDIST/TESTING. Skip BLACS/TESTING
    in debian/scalapack-mpi-test.install. See Bug#1097848 and
    https://github.com/Reference-ScaLAPACK/scalapack/issues/148
  * enable s390x build tests via oversubscribe. Closes: #1095323.
  * set myself as Uploader. Closes: #1107179.
  * Standards-Version: 4.7.2

 -- Drew Parsons <dparsons@debian.org>  Mon, 03 Nov 2025 18:51:09 +0100

scalapack (2.2.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream release
    - applies debian patches pblas_testing.patch
      and scalapack_testing.patch
    - updates cmake config to SCALAPACK_BUILD_TESTS
      not SCALAPACK_BUILD_TESTING
  * most of debian patch blacs_testing.patch is now applied upstream
  * drop debian patch restore_mpifort_revert_PR39.patch (MPI build is
    fixed by upstream MRs #57 and #67)

 -- Drew Parsons <dparsons@debian.org>  Sat, 11 Jan 2025 20:47:15 +0100

scalapack (2.2.1-7) unstable; urgency=medium

  * Team upload.
  * provide 64-bit definition for Depends: ${scalapack64-mpi-dev}
    (defined as the build for the default MPI)

 -- Drew Parsons <dparsons@debian.org>  Tue, 26 Nov 2024 01:47:43 +0100

scalapack (2.2.1-6) unstable; urgency=medium

  * Team upload.
  * OpenMPI 5.0 changed the name of the environment variable to set the SSH
    agent from
       export OMPI_MCA_plm_rsh_agent=/bin/false
    to
       export PRTE_MCA_plm_ssh_agent=/bin/false
    Use the new variable name in debian/rules.
  * Set lower bound >= 1.17 to Build-Depends: mpi-default-dev because the
    environment variable PRTE_MCA_plm_ssh_agent is set at build time in
    debian/rules.

 -- Francesco Ballarin <francesco.ballarin@unicatt.it>  Wed, 20 Nov 2024 09:58:49 +0000

=== debian/control ===
Source: scalapack
Section: devel
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Drew Parsons <dparsons@debian.org>
Standards-Version: 4.7.2
Build-Depends: debhelper-compat (= 13),
 cmake,
 mpi-default-dev (>= 1.17),
 mpi-default-bin,
 libopenmpi-dev [!armel !armhf !i386 !hurd-i386 !hppa !m68k !powerpc !sh4 !x32],
 mpich, libmpich-dev,
 gfortran,
 libblas-dev | libopenblas-dev | libatlas-base-dev | libblas.so,
 liblapack-dev | libopenblas-dev | libatlas-base-dev | liblapack.so,
 libblas64-dev [!armel !armhf !i386 !hppa !hurd-i386 !m68k !powerpc !sh4 !x32]
   | libopenblas64-dev [!armel !armhf !i386 !hppa !hurd-i386 !m68k !powerpc !sh4 !x32]
   | libatlas64-base-dev [!armel !armhf !i386 !hppa !hurd-i386 !m68k !powerpc !sh4 !x32]
   | libblas64.so [!armel !armhf !i386 !hppa !hurd-i386 !m68k !powerpc !sh4 !x32],
 liblapack64-dev [!armel !armhf !i386 !hppa !hurd-i386 !m68k !powerpc !sh4 !x32]
   | libopenblas64-dev [!armel !armhf !i386 !hppa !hurd-i386 !m68k !powerpc !sh4 !x32]
   | libatlas64-base-dev [!armel !armhf !i386 !hppa !hurd-i386 !m68k !powerpc !sh4 !x32]
   | liblapack64.so [!armel !armhf !i386 !hppa !hurd-i386 !m68k !powerpc !sh4 !x32],
 pkgconf,
 bc,
 chrpath
Homepage: https://www.netlib.org/scalapack/
Vcs-Git: https://salsa.debian.org/science-team/scalapack.git
Vcs-Browser: https://salsa.debian.org/science-team/scalapack

Package: libscalapack-openmpi2.2
Section: libs
Architecture: alpha amd64 arm64 hurd-amd64 ia64 kfreebsd-amd64 loong64 mips64el ppc64 ppc64el riscv64 s390x sparc64
Multi-Arch: same
Depends: mpi-default-bin, ${shlibs:Depends}, ${misc:Depends}
Conflicts: scalapack2-mpich
Breaks: libscalapack-mpi1 (<< 1.8.0-9.1)
Replaces: scalapack1-mpich, libscalapack-mpi1 (<< 1.8.0-9.1)
Suggests: scalapack-doc
Description: Scalable Linear Algebra Package - Shared libs for OpenMPI
 ScaLAPACK is the parallel version of LAPACK used on clusters.
 .
 There are packages for the shared libraries (this one), for the
 static libraries and the development files and for test programs.
 .
 Also included:
   - PBLAS, Parallel Basic Linear Algebra Subprograms
   - BLACS, Basic Linear Algebra Communication Subprograms
 .
 This package supports the OpenMPI implementation of MPI.

Package: libscalapack-mpich2.2
Section: libs
Architecture: any
Multi-Arch: same
Depends: mpi-default-bin, ${shlibs:Depends}, ${misc:Depends}
Conflicts: scalapack2-mpich
Breaks: libscalapack-mpi1 (<< 1.8.0-9.1)
Replaces: scalapack1-mpich, libscalapack-mpi1 (<< 1.8.0-9.1)
Suggests: scalapack-doc
Description: Scalable Linear Algebra Package - Shared libs for MPICH
 ScaLAPACK is the parallel version of LAPACK used on clusters.
 .
 There are packages for the shared libraries (this one), for the
 static libraries and the development files and for test programs.
 .
 Also included:
   - PBLAS, Parallel Basic Linear Algebra Subprograms
   - BLACS, Basic Linear Algebra Communication Subprograms
 .
 This package supports the MPICH implementation of MPI.

Package: libscalapack-mpi-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${scalapack-mpi-dev}, mpi-default-dev, ${misc:Depends}
Replaces: libblacs-mpi-dev
Provides: libblacs-mpi-dev
Suggests: scalapack-doc
Description: Scalable Linear Algebra Package - Dev files for MPI
 ScaLAPACK is the parallel version of LAPACK used on clusters.
 .
 There are packages for the shared libraries, for the static libraries and
 the development files (this one) and for test programs.
 .
 Also included:
    - PBLAS, Parallel Basic Linear Algebra Subprograms
    - BLACS, Basic Linear Algebra Communication Subprograms
 .
 This is a dummy package which depends on the scalapack development package
 supporting the default implementation of MPI on this architecture.

Package: libscalapack-mpich-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libscalapack-mpich2.2 (= ${binary:Version}), ${misc:Depends}
Breaks: libscalapack-mpi-dev (<< 2.0.2-1)
Replaces: libblacs-mpi-dev
Provides: libblacs-mpi-dev
Suggests: scalapack-doc
Description: Scalable Linear Algebra Package - Dev files for MPICH
 ScaLAPACK is the parallel version of LAPACK used on clusters.
 .
 There are packages for the shared libraries, for the static libraries and
 the development files (this one) and for test programs.
 .
 Also included:
    - PBLAS, Parallel Basic Linear Algebra Subprograms
    - BLACS, Basic Linear Algebra Communication Subprograms
 Also included: PBLAS, Parallel Basic Linear Algebra Subprograms.
 .
 This package supports the MPICH implementation of MPI.

Package: libscalapack-openmpi-dev
Section: libdevel
Architecture: alpha amd64 arm64 hurd-amd64 ia64 kfreebsd-amd64 loong64 mips64el ppc64 ppc64el riscv64 s390x sparc64
Multi-Arch: same
Depends: libscalapack-openmpi2.2 (= ${binary:Version}), ${misc:Depends}
Breaks: libscalapack-mpi-dev (<< 2.0.2-1)
Replaces: libblacs-mpi-dev
Provides: libblacs-mpi-dev
Suggests: scalapack-doc
Description: Scalable Linear Algebra Package - Dev files for OpenMPI
 ScaLAPACK is the parallel version of LAPACK used on clusters.
 .
 There are packages for the shared libraries, for the static libraries and
 the development files (this one) and for test programs.
 .
 Also included:
    - PBLAS, Parallel Basic Linear Algebra Subprograms
    - BLACS, Basic Linear Algebra Communication Subprograms
 .
 This package supports the OpenMPI implementation of MPI.

Package: libscalapack64-openmpi2.2
Section: libs
Architecture: alpha amd64 arm64 hurd-amd64 ia64 kfreebsd-amd64 loong64 mips64el ppc64 ppc64el riscv64 s390x sparc64
Multi-Arch: same
Depends: mpi-default-bin, ${shlibs:Depends}, ${misc:Depends}
Suggests: scalapack-doc
Description: Scalable Linear Algebra Package - 64-bit Shared libs for OpenMPI
 ScaLAPACK is the parallel version of LAPACK used on clusters.
 .
 There are packages for the shared libraries (this one), for the
 static libraries and the development files and for test programs.
 .
 Also included:
   - PBLAS, Parallel Basic Linear Algebra Subprograms
   - BLACS, Basic Linear Algebra Communication Subprograms
 .
 This package provides 64 bit integer support and uses the OpenMPI
 implementation of MPI.

Package: libscalapack64-mpich2.2
Section: libs
Architecture: any
Multi-Arch: same
Depends: mpi-default-bin, ${shlibs:Depends}, ${misc:Depends}
Conflicts: scalapack2-mpich
Breaks: libscalapack-mpi1 (<< 1.8.0-9.1)
Replaces: scalapack1-mpich, libscalapack-mpi1 (<< 1.8.0-9.1)
Suggests: scalapack-doc
Description: Scalable Linear Algebra Package - 64-bit Shared libs for MPICH
 ScaLAPACK is the parallel version of LAPACK used on clusters.
 .
 There are packages for the shared libraries (this one), for the
 static libraries and the development files and for test programs.
 .
 Also included:
   - PBLAS, Parallel Basic Linear Algebra Subprograms
   - BLACS, Basic Linear Algebra Communication Subprograms
 .
 This package provides 64 bit integer support and uses the MPICH
 implementation of MPI.

Package: libscalapack64-mpi-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${scalapack64-mpi-dev}, mpi-default-dev, ${misc:Depends}
Replaces: libblacs-mpi-dev
Provides: libblacs-mpi-dev
Suggests: scalapack-doc
Description: Scalable Linear Algebra Package - 64-bit Dev files for MPI
 ScaLAPACK is the parallel version of LAPACK used on clusters.
 .
 There are packages for the shared libraries, for the static libraries and
 the development files (this one) and for test programs.
 .
 Also included:
    - PBLAS, Parallel Basic Linear Algebra Subprograms
    - BLACS, Basic Linear Algebra Communication Subprograms
 .
 This is a dummy package which depends on the scalapack development package
 supporting the default implementation of MPI on this architecture and
 providing 64 bit integer support.

Package: libscalapack64-mpich-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libscalapack64-mpich2.2 (= ${binary:Version}), ${misc:Depends}
Suggests: scalapack-doc
Description: Scalable Linear Algebra Package - 64-bit Dev files for MPICH
 ScaLAPACK is the parallel version of LAPACK used on clusters.
 .
 There are packages for the shared libraries, for the static libraries and
 the development files (this one) and for test programs.
 .
 Also included:
    - PBLAS, Parallel Basic Linear Algebra Subprograms
    - BLACS, Basic Linear Algebra Communication Subprograms
 Also included: PBLAS, Parallel Basic Linear Algebra Subprograms.
 .
 This package provides 64 bit integer support and uses the MPICH
 implementation of MPI.

Package: libscalapack64-openmpi-dev
Section: libdevel
Architecture: alpha amd64 arm64 hurd-amd64 ia64 kfreebsd-amd64 loong64 mips64el ppc64 ppc64el riscv64 s390x sparc64
Multi-Arch: same
Depends: libscalapack64-openmpi2.2 (= ${binary:Version}), ${misc:Depends}
Suggests: scalapack-doc
Description: Scalable Linear Algebra Package - 64-bit Dev files for OpenMPI
 ScaLAPACK is the parallel version of LAPACK used on clusters.
 .
 There are packages for the shared libraries, for the static libraries and
 the development files (this one) and for test programs.
 .
 Also included:
    - PBLAS, Parallel Basic Linear Algebra Subprograms
    - BLACS, Basic Linear Algebra Communication Subprograms
 .
 This package provides 64 bit integer support and uses the OpenMPI
 implementation of MPI.

Package: scalapack-mpi-test
Section: math
Architecture: any
Multi-Arch: same
Depends: scalapack-test-common, ${shlibs:Depends}, ${misc:Depends}
Recommends: cmake
Conflicts: scalapack-mpich-test
Replaces: scalapack-mpich-test, blacs-mpi-test
Provides: scalapack-mpich-test, blacs-mpi-test
Suggests: scalapack-doc
Description: Scalable Linear Algebra Package - Test files for MPI
 ScaLAPACK is the parallel version of LAPACK used on clusters.
 .
 Also included:
    - PBLAS, Parallel Basic Linear Algebra Subprograms
    - BLACS, Basic Linear Algebra Communication Subprograms
 .
 This package contains ScaLAPACK, PBLAS and BLACS test programs.

Package: scalapack-test-common
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Replaces: blacs-test-common
Provides: blacs-test-common
Suggests: scalapack-mpi-test
Description: Test data for ScaLAPACK testers
 ScaLAPACK is the parallel version of LAPACK used on clusters.
 .
 Also included:
    - PBLAS, Parallel Basic Linear Algebra Subprograms
    - BLACS, Basic Linear Algebra Communication Subprograms
 .
 This package contains data files used by test programs.

=== debian/rules ===
#! /usr/bin/make -f

include /usr/share/dpkg/architecture.mk

# eventually add -O3 -march=native -mtune=native
export DEB_BUILD_MAINT_OPTIONS = qa=-bug-implicit-func
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_CXXFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_FFLAGS_MAINT_APPEND  = -std=legacy
export DEB_LDFLAGS_MAINT_STRIP = -Wl,-Bsymbolic-functions

# DEB_BUILD_MAINT_OPTIONS qa is ignored on powerpc, Bug#1082275
ifeq ($(DEB_HOST_ARCH),powerpc)
  DEB_CFLAGS_MAINT_APPEND += -Wno-error=implicit-function-declaration
endif

ifneq (,$(wildcard /usr/share/mpi-default-dev/debian_defaults))
include /usr/share/mpi-default-dev/debian_defaults
endif
DEFAULT_MPI=$(ARCH_DEFAULT_MPI_IMPL)

empty :=
space := $(empty)$(empty)

export MPI_SUPPORTED=
ifneq (,$(findstring $(space)$(DEB_HOST_ARCH)$(space), $(space)$(OPENMPI_AVAILABLE_ARCHITECTURES)$(space)))
  MPI_SUPPORTED += openmpi
endif
ifneq (,$(findstring $(space)$(DEB_HOST_ARCH)$(space), $(space)$(MPICH_AVAILABLE_ARCHITECTURES)$(space)))
  MPI_SUPPORTED += mpich
endif

include /usr/share/dpkg/pkg-info.mk
SCALAPACK_UPSTREAM_VERSION=$(DEB_VERSION_UPSTREAM)
SCALAPACK_X_Y_VERSION=$(shell echo $(SCALAPACK_UPSTREAM_VERSION) | sed "s/^\(.*\)\.\([^.]*\)$$/\1/")
export SCALAPACK_SOVERSION=$(SCALAPACK_X_Y_VERSION)

# 64-bit build is not supported on all arches
ifeq (64,$(DEB_HOST_ARCH_BITS))
  BIT_BUILDS = 32 64
else
  BIT_BUILDS = 32
  export DH_OPTIONS += \
	-Nlibscalapack64-mpi-dev \
	-Nlibscalapack64-openmpi-dev -Nlibscalapack64-openmpi${SCALAPACK_SOVERSION} \
	-Nlibscalapack64-mpich-dev -Nlibscalapack64-mpich${SCALAPACK_SOVERSION}
endif

%:
	dh $@ --buildsystem=cmake

export PRTE_MCA_plm_ssh_agent=/bin/false                #workaround to start MPI-applications in chroot
export PRTE_MCA_rmaps_default_mapping_policy=:oversubscribe

export NUMJOBS=1
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
export NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

extra_flags += \
 -DBUILD_SHARED_LIBS=ON \
 -DSCALAPACK_BUILD_TESTS=ON \
 -DBLA_VENDOR=Generic

# BLA_SIZEOF_INTEGER is a cmake FindLAPACK variable to find 32- or 64-bit interfaces
extra_64bit_flags += \
	-DLIBNAME_SUFFIX=64 \
	-DBLA_SIZEOF_INTEGER=8

common_Fortran_FLAGS=-cpp
Fortran_FLAGS_64=-fdefault-integer-8 -DTEST_INT64=1
C_FLAGS_64=-DInt=long

execute_after_dh_clean:
	cd BLACS/INSTALL; rm -rf xintface Makefile CMakeCache.txt cmake_install.cmake CMakeFiles
	cd PBLAS; rm -f TESTING/PB_Cabort.c TESTING/PB_Cwarn.c TIMING/PB_Cabort.c TIMING/PB_Cwarn.c
	rm -rf build*-openmpi build*-mpich

override_dh_auto_configure-indep:
override_dh_auto_build-indep:
override_dh_auto_install-indep:
override_dh_auto_test-indep:


override_dh_auto_configure-arch:
	for flavor in $(MPI_SUPPORTED); do \
	for BITS in $(BIT_BUILDS); do \
	  if [ $$BITS = 64 ]; then \
	    LIBNAME_SUFFIX=64; \
	    bit_flags='$(extra_64bit_flags)'; \
	    extra_C_FLAGS="$(C_FLAGS_64)"; \
	    extra_Fortran_FLAGS="$(Fortran_FLAGS_64)"; \
	  else \
	    LIBNAME_SUFFIX=; \
	    bit_flags=; \
	    extra_C_FLAGS=; \
	    extra_Fortran_FLAGS=; \
	  fi; \
	  echo "Configure for libscalapack$${LIBNAME_SUFFIX}-$${flavor}" ; \
	  dh_auto_configure --builddirectory=build$${LIBNAME_SUFFIX=}-$${flavor} -- $(extra_flags) $${bit_flags} \
	    "-DCMAKE_C_FLAGS=$(CFLAGS) $${extra_C_FLAGS}"  \
	    "-DCMAKE_Fortran_FLAGS=$(FFLAGS) $(common_Fortran_FLAGS) $${extra_Fortran_FLAGS}" \
	    -DMPI_C_COMPILER=mpicc.$$flavor -DMPI_Fortran_COMPILER=mpif90.$$flavor \
	    -DMPIEXEC_EXECUTABLE=/usr/bin/mpiexec.$$flavor -DMPI_FLAVOR=$$flavor ; \
	done; done

override_dh_auto_build-arch:
	for flavor in $(MPI_SUPPORTED); do \
	for BITS in $(BIT_BUILDS); do \
	  if [ $$BITS = 64 ]; then \
	    LIBNAME_SUFFIX=64; \
	  else \
	    LIBNAME_SUFFIX=; \
	  fi; \
	  echo "Building libscalapack$${LIBNAME_SUFFIX}-$${flavor}" ; \
	  dh_auto_build -O--parallel --builddirectory=build$${LIBNAME_SUFFIX}-$${flavor} ; \
	done; done

override_dh_auto_install-arch:
	echo "scalapack-mpi-dev=libscalapack-$(DEFAULT_MPI)-dev" > debian/libscalapack-mpi-dev.substvars
	echo "scalapack64-mpi-dev=libscalapack64-$(DEFAULT_MPI)-dev" > debian/libscalapack64-mpi-dev.substvars
	for flavor in $(MPI_SUPPORTED); do \
	for BITS in $(BIT_BUILDS); do \
	  if [ $$BITS = 64 ]; then \
	    LIBNAME_SUFFIX=64; \
	  else \
	    LIBNAME_SUFFIX=; \
	  fi; \
	  echo "Installing scalapack$${LIBNAME_SUFFIX}-$${flavor}" ; \
	  dh_auto_install -O--parallel --builddirectory=build$${LIBNAME_SUFFIX}-$${flavor} ; \
	done; done

execute_after_dh_install-arch:
	dh_missing --list-missing
	# test executables contain RUNPATH. Remove it.
	chrpath -d debian/scalapack-mpi-test/usr/lib/$(DEB_HOST_MULTIARCH)/scalapack/*-tests/x*
	chrpath -d debian/scalapack-mpi-test/usr/lib/$(DEB_HOST_MULTIARCH)/scalapack/*-tests/PBLAS/*tst
	chrpath -d debian/scalapack-mpi-test/usr/lib/$(DEB_HOST_MULTIARCH)/scalapack/*-tests/PBLAS/TIMING/*tim


# add --max-parallel=1 to force test in sequential mode
# MPICH testsuite disabled as some tests fail -- why???

# Note: openmpi tests routinely (but unreproducibly) fail on some buildds,
# so don't let test failure halt the build on these arches (but let the tests run)
ARCH_TEST_IGNORE_FAILURE=mips64el

# On some other arches, openmpi3 tests never exit (don't even timeout),
# so skip their tests altogether until a workaround or fix is known.
ARCH_NO_OPENMPI_TEST_LIST=armel armhf i386 mipsel powerpc

# The hppa build does complete, but takes a full day to timeout on half the openmpi3 tests.
# That's too long, so add it to the no-test list
ARCH_NO_OPENMPI_TEST_LIST += hppa

# complex evr tests often time out, and are significantly slower than other tests
# even if they do pass. Skip them both.
SKIP_TESTS_COMMON=x[cz]heevr

# no current general 32-bit skips (see *MPI skips below)
SKIP_TESTS_32 ?=

# xssep, xsgsep and xssyevr are known to fail in the 64-bit build (see README)
# xdsyevr passes but is slow, skip it
SKIP_TESTS_64=xssep xsgsep xssyevr xdsyevr xCbtest xFbtest

# xsllt times out with OpenMPI, but xdllt, xdlu time out with MPICH.
# but all pass in the 64-bit builds. Weird.
SKIP_TESTS_OPENMPI=xsllt
SKIP_TESTS_MPICH=xdllt xdlu

override_dh_auto_test-arch:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	N_TEST_JOBS=`echo "x=$(NUMJOBS)/4; if (x>1) x else 1" | bc` ; \
	exclude_tests=""; \
	for t in $(SKIP_TESTS_COMMON); do \
	  if [ "x$${exclude_tests}" = "x" ]; then \
	    exclude_tests="$$t"; \
	  else \
	    exclude_tests="$${exclude_tests}|$$t"; \
	  fi; \
	done; \
	for BITS in $(BIT_BUILDS); do \
	  if [ $$BITS = 64 ]; then \
	    LIBNAME_SUFFIX=64; \
	    for t in $(SKIP_TESTS_64); do \
	        exclude_tests="$${exclude_tests}|$$t"; \
	    done; \
	  else \
	    LIBNAME_SUFFIX=; \
	    for t in $(SKIP_TESTS_32); do \
	        exclude_tests="$${exclude_tests}|$$t"; \
	    done; \
	  fi; \
	  for flavor in $(MPI_SUPPORTED); do \
	    echo "Running tests for libscalapack$${LIBNAME_SUFFIX}-$${flavor}" ; \
	    echo '************************************************'; \
	    echo "****** TESTING $$flavor BUILD ($${BITS}-bit integers)"; \
	    echo '************************************************'; \
	    for testDir in PBLAS/TESTING PBLAS/TIMING TESTING; do \
	      testfile=build$${LIBNAME_SUFFIX}-$${flavor}/$${testDir}/CTestTestfile.cmake; \
	      if ! grep -q separate_arguments.*ENV.*MPIEXEC_PREFLAGS $$testfile ; then \
	        sed '0,/add_test/ s/add_test/separate_arguments(MPIEXEC_PREFLAGS NATIVE_COMMAND $$ENV{MPIEXEC_PREFLAGS})\nadd_test/' -i $$testfile; \
	        sed 's/"$${MPIEXEC_PREFLAGS}"/$${MPIEXEC_PREFLAGS}/' -i $$testfile; \
	      fi; \
	    done; \
	    RUNTESTS=yes; \
	    if [ "$$flavor" = "openmpi" ]; then \
	      MPIEXEC_PREFLAGS="--allow-run-as-root --oversubscribe"; \
	      case " $(ARCH_NO_OPENMPI_TEST_LIST) " in \
	        *\ $(DEB_HOST_ARCH)\ *) RUNTESTS=no;; \
	      esac; \
	      for t in $(SKIP_TESTS_OPENMPI); do \
	          exclude_tests="$${exclude_tests}|$$t"; \
	      done; \

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%scalapack-$1.tar.gz%" \
 https://github.com/Reference-ScaLAPACK/scalapack/tags \
 (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
